var STATUS_ERROR = -1;             //错误
var STATUS_CAN_BE_INSTALLED = 1;   //安装
var STATUS_INSTALLING  = 2;        //正在安装
var STATUS_INSTALLED  = 3;         //已安装
var STATUS_CAN_BE_REMOVED = 4;     //卸载
var STATUS_REMOVING  = 5;          //正在卸载
var STATUS_REMOVED  = 6;           //已卸载
var STATUS_CAN_BE_UPGRADED  = 7;   //升级
var STATUS_UPGRADING = 8;          //正在升级
var STATUS_UPGRADED = 9;           //已升级
var STATUS_CAN_BE_CANCEL = 10;     //取消
var STATUS_CANCELING = 11;         //正在取消
var STATUS_CANCELED = 12;          //已取消
var STATUS_CAN_BE_PAUSE = 13;      //暂停
var STATUS_PAUSING = 14;           //正在暂停
var STATUS_PAUSED = 15;            //已暂停
var STATUS_UPGRADE_FAILED = 18;    //升级失败
var STATUS_DOWNLOADING = 19;       //正在下载
var STATUS_WAITDOWNLOAD = 20;      //等待下载
var STATUS_FINISHDOWNLOAD = 21;    //下载结束
var STATUS_WAITINSTALL = 22;       //等待安装
var STATUS_DOWNLOADFAILD = 23;     //下载失败
var STATUS_REDOWNLOAD = 24;        //继续下载
var STATUS_WAITINGAUTHORIZATION=25;//等待授权

var IGNORED_NO = 0;                 //非忽略软件
var IGNORED_YES = 1;                //忽略软件

var SYS_NO = 0;                     //非系统软件
var SYS_YES = 1;                    //系统软件

var RECOMMEND_NO = 0;               //非推荐软件
var RECOMMEND_YES = 1;              //推荐软件

var RECORD_NO = 0;                  //非录入软件
var RECORD_YES = 1;                 //录入软件

var OFFLINE_YES = -1;               //离线软件
var OFFLINE_NO = 0;                 //非离线软件
var OFFLINE_LOCAL = 1;              //本地源

var SORT_FIELD_TITLE = "title";     //名称
var SORT_FIELD_SIZE = "size";       //大小
var SORT_FIELD_STAR = "score/ratercount";               //星级
var SORT_FIELD_TIME = "checkedTime";                    //上新时间

var SORT_ASC = "asc";               //升序
var SORT_DESC = "desc";             //倒序

$(function(){
//    document.onclick=function(){Cos.jsHideAptTaskDialog();}
    //安装按钮被点击
    $(".installSoftware").not('.pauseAPTTask .openSoftware').on('click', function(){
                installSoftware_click($(this));
    });

    $(".continueInstallSoftware").live('click', function(){
                continueDownload($(this));
    });

    $(".removeSoftware").not('.pauseAPTTask').on('click', function(){
        removeSoftware_click($(this));
    });

    $(".ignoreSoftware").on('click', function(){
        ignoreSoftware_click($(this));
    });

    $(".recoverSoftware").on('click', function(){
        recoverSoftware_click($(this));
    });

    $(".upgradeSoftware").not('.pauseAPTTask').on('click', function(){
        upgradeSoftware_click($(this));
    });

    $(".cancelAPTTask").on('click', function(){
        cancelAPTTask_click($(this));
    });

    $(".pauseAPTTask").on('click', function(){
        pauseAPTTask_click($(this));
    });

    $(".fl_img img").error(function(){
        img_error($(this));
    });
    $(".openSoftware").on("click", function(){
	    opensoftware_click($(this));
    });
	
    $(".table_d_tittle").click(function(){
        if($(this).next().css("display") === "none"){
	    $(".table_d_tittle").next().hide();
            $(this).next().show();
        }else {
            $(this).next().hide();
        }
    	maxSize(27);
    });
    
    $(".hideAPTTask_small").click(function(){
        hideAPTTask_small_click($(this));
    });

    $(".showAPTTask_page").click(function(){
        showAPTTask_page_click($(this));
    });
});
function setText(obj, text){
	if(obj.is('a')){
		obj.text(text);
	}else{
		obj.val(text);
	}
}

function open_application_by_cmd(cmd)
{
    openApp(cmd);
}

function opensoftware_click(object){
    if(object.attr("packageName") == "wps-office" ||
        object.attr("packageName") == "kingsoft-office"  )
    {
        $.artDialog.open('wps.html', {
            id:"pen_wps",
            width:280,
            height: 210,
            title: '',
            padding: '0',
            lock:true
        }, false);

        return;
    }

	setText(object,"正在打开");
	object.attr("disabled",true).addClass("disabled");
	window.setTimeout(function(){
		setText(object,"打开");
		object.removeAttr("disabled").removeClass("disabled");
	}, 3000);
        openSoftware(object.attr("packageName"));
}
function continueDownload(object){
    var e = event || window.event;
    var x = e.screenX;
    var y = e.screenY;
    if(!object.hasClass("disabled") && !object.hasClass("openSoftware")){
        if(getOffline() === OFFLINE_YES){

            $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试安装。");
        }else {
        if($(".showAPTTasks_small").size() > 0){
        object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
        }else{
        object.addClass("disabled");
        setText(object,"正在下载");
        }
//            changeProgressSingle(50, object.attr("software"), STATUS_DOWNLOADING, "等待");
            continueDownloading(object.attr("software"), object.attr("cversion"));
//        $.getJSON(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install"});
        }
    }
}
//安装按钮点击后执行操作
function installSoftware_click(object){
    var e = event || window.event;
    var x = e.screenX;
    var y = e.screenY;
log("~~~ installSoftware_click");
    var winuxgear_exist = getWinuxgearStatus();
    if(winuxgear_exist == false && object.attr("software").indexOf("winuxapp") == 0)
	{
	    $.artDialog.alert("未安装Winuxgear环境，无法安装Windows应用");
	    return;
	}

    var flagupdate = getUpdateFlagApt();
    if(flagupdate == true)
	{
          $.artDialog.alert("正在更新源，请稍后...");
          return;
	}
    //获取网络状态
    var netStatus = getOffline();
    //断网模式
    if(netStatus === OFFLINE_YES){
        $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试安装。");
    }else if(netStatus === OFFLINE_LOCAL){   //本地源
        animation(object.attr("software"),x,y);
        object.addClass("disabled");
        object.val("等待下载");
        changeProgressSingle(-1, object.attr("software"), STATUS_WAITDOWNLOAD, "等待下载");
      //  $.getJSON(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install"});
        installSoftware(object.attr("software"), object.attr("cversion"));
    }else if(netStatus === OFFLINE_NO){     //在线
        // animation(object.attr("software"),x,y); // 20171017 gaoshun del
        //如果存在这个disabled
        if(object.hasClass("disabled")){
            return;
        }
        animation(object.attr("software"),x,y); // 20171017 gaoshun add 修改下载中点击按钮还会出现下载动画的问题
        object.addClass("disabled");
        object.val("等待下载");
        changeProgressSingle(-1, object.attr("software"), STATUS_WAITDOWNLOAD, "等待下载");
      //  var std = $.getJSON(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install",swPackageName:object.attr("software")});
	var tmpmail = getUserMail();
	if(tmpmail == null || tmpmail == "")
		    tmpmail = "niming@123.com";
        //$.post(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install", swPackageName:object.attr("software"), usermail:tmpmail},function(data){$('#downloadupdate').text("下载："+data.totalDownloadCount);});
	var tmpsoftname = object.attr("software");
        ajaxPost(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install", swPackageName:object.attr("software"), userMail:tmpmail},function(data){$('#downloadupdate').text("下载："+data.totalDownloadCount);
	$("td[downsoftwarename="+tmpsoftname+"]").text(data.totalDownloadCount+"次");});
        installSoftware(object.attr("software"), object.attr("cversion"));
	showAPTTask_page();
    }

//    if(!object.hasClass("disabled") && !object.hasClass("openSoftware")){
//        //当前没有联网，但是通常情况下不会出现
//        if(getOffline() === OFFLINE_YES){
//            $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试安装。");
//        }else {
//	        if($(".showAPTTasks_small").size() > 0){
//		        object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
//	        }else{
//                //界面效果
//                animation(object.attr("software"),x,y);
//		        object.addClass("disabled");
//		        setText(object,"正在安装");
//	        }
//            changeProgressSingle(0, object.attr("software"), STATUS_INSTALLING, "等待");
//            installSoftware(object.attr("software"), object.attr("cversion"));
// 	        $.getJSON(urls.url+"/updateSoftwareCount_JSON.action",{swid:object.attr("swid"), type:"install"});
//        }
//    }
}

function removeSoftware_click(object){
    var e = event || window.event;
    var x = e.screenX;
    var y = e.screenY;
    var flagupdate = getUpdateFlagApt();
    var winuxgear_exist = getWinuxgearStatus();
    if(winuxgear_exist == false && object.attr("packageName").indexOf("winuxapp") == 0)
	{
	    $.artDialog.alert("未安装Winuxgear环境，无法卸载Windows应用");
	    return;
	}
    if(flagupdate == true)
	{
          //  $.artDialog.alert("正在更新源，请稍后...");
	}
    if(!object.hasClass("disabled")){
        if(object.hasClass("btn_continue")){
            if($(".showAPTTasks_small").size() > 0){
                    object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
            }else{
                    //animation(object.attr("packageName"), x, y);
                    object.addClass("disabled");
                    setText(object,"正在卸载");
            }
            changeProgressSingle(0, object.attr("packageName"), STATUS_REMOVING, "等待");
            removeSoftware(object.attr("packageName"), object.attr("cv"));
		showAPTTask_page();
            return;
        }

        if(Cos.getProcessIsRunning(object.attr("packageName")))
        {

        }
        if(parseInt(object.attr("sys")) === SYS_YES){
            $.artDialog.alert(object.attr("title") + " 是系统相关软件，卸载将影响系统正常使用，不允许卸载！");
        }else {
	    if(Cos.getProcessIsRunning(object.attr("packageName")))
	    {
		 $.artDialog.confirm("   正在运行，是否确认卸载"+object.attr("title")+" ？  ",function(){
		if($(".showAPTTasks_small").size() > 0){
			object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
		}else{
										                             	object.addClass("disabled");
										                             	setText(object,"正在卸载");
										                     	     }
		changeProgressSingle(0, object.attr("packageName"), STATUS_REMOVING, "等待");
		removeSoftware(object.attr("packageName"), object.attr("cv"));
		showAPTTask_page();
	     });

	    }
	    else
	    {
            	$.artDialog.confirm("   是否确认卸载"+object.attr("title")+" ？  ",function(){
                    if($(".showAPTTasks_small").size() > 0){
                            object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
                    }else{
                            object.addClass("disabled");
                            setText(object,"正在卸载");
                    }
                    changeProgressSingle(0, object.attr("packageName"), STATUS_REMOVING, "等待");
                    removeSoftware(object.attr("packageName"), object.attr("cv"));
			showAPTTask_page();
           	});
	  }

        }
    }
}

function ignoreSoftware_click(object){
    ignoreSoftware(object.attr("packageName"), object.attr("nv"));
}

function recoverSoftware_click(object){
    recoverSoftware(object.attr("packageName"), object.attr("nv"));
}

function showIgnoredSoftware(packageName, ignored){
    if(ignored === IGNORED_YES){
        $(".showUpgradeSoftwares.ignored").prepend($(".showUpgradeSoftwares [id='" + packageName + "']"));
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_recover").show();
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_ignore").hide();
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_upgrade").hide();
        $(".upgrade_total_count").text(parseInt($(".upgrade_total_count").first().text()) - 1);
        //$(".free_count").text(parseInt($(".free_count").first().text()) - 1);
        $(".canBeUpgraded_count").text(parseInt($(".canBeUpgraded_count").first().text()) - 1);
        $(".ignored_count").text(parseInt($(".ignored_count").first().text()) + 1);
    }else {
        $(".showUpgradeSoftwares.canBeUpgraded").prepend($(".showUpgradeSoftwares [id='" + packageName + "']"));
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_recover").hide();
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_ignore").show();
        $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_upgrade").show();
        $(".upgrade_total_count").text(parseInt($(".upgrade_total_count").first().text()) + 1);
        $(".canBeUpgraded_count").text(parseInt($(".canBeUpgraded_count").first().text()) + 1);
        $(".ignored_count").text(parseInt($(".ignored_count").first().text()) - 1);
    }
}
function upgradeSoftware_click(object){
    var e = event || window.event;
    var x = e.screenX;
    var y = e.screenY;
    var winuxgear_exist = getWinuxgearStatus();
    if(winuxgear_exist == false && object.attr("packageName").indexOf("winuxapp") == 0)
	{
	    $.artDialog.alert("未安装Winuxgear环境，无法更新Windows应用");
	    return;
	}
    if(!object.hasClass("disabled")){
        if(getOffline() === OFFLINE_YES){
            $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试升级。");
        }else {
             animation(object.attr("packageName"),x,y);
             object.addClass("disabled").val("等待升级");
             object.prev().addClass("disabled").hide();
             upgradeSoftware(object.attr("packageName"), object.attr("nv"));
		showAPTTask_page();
        }
//        if(object.hasClass("btn_continue"))
//        {
//            if($(".showAPTTasks_small").size() > 0){
//            object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
//            }else{
//            object.addClass("disabled");
//            setText(object,"正在升级");
//            }
//                changeProgressSingle(0, object.attr("packageName"), STATUS_UPGRADING, "等待");
//                upgradeSoftware(object.attr("packageName"), object.attr("nv"));
//            return;
//        }

//        if(getOffline() === OFFLINE_YES){
//            $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试升级。");
//        }else {
//            animation(object.attr("packageName"),x,y);
//            if($(".showAPTTasks_small").size() > 0){
//                object.val("||").removeClass("btn_continue").addClass("btn_pause").addClass("pauseAPTTask");
//            }else{
//                object.addClass("disabled");
//                setText(object,"正在升级");
//            }
//            changeProgressSingle(0, object.attr("packageName"), STATUS_UPGRADING, "等待");
//            upgradeSoftware(object.attr("packageName"), object.attr("nv"));
//        }
    }
}

/*
* 任务取消功能函数
*
*/
function cancelAPTTask_click(object){
     //如果是下载失败或任务失败直接移除进度表
    if(!object.hasClass("disabled") && $(".showAPTTasks_small").length > 0){
        cancelAPTTask(object.parents("li").attr("software"), object.parents("li").attr("cversion"));
    }
}

function pauseAPTTask_click(object){

    if(!object.hasClass("disabled") && $(".showAPTTasks_small").length > 0){

        object.parents("li").find(":submit.btn_pause").hide();
        object.parents("li").find(":submit.btn_continue").show();

        //这个是用来处理断点续传
        if(object.parents("li").hasClass("continueDownload")){
            object.parents("li").removeClass("continueDownload");
        }

        pauseAPTTask(object.parents("li").attr("software"), object.parents("li").attr("cversion"));

    }
}

/**
  * 继续下载
  */
function continueDownloadAPTTask_click(object){
    var e = event || window.event;
    var x = e.screenX;
    var y = e.screenY;
    if(!object.hasClass("disabled") && $(".showAPTTasks_small").length > 0){
        if(getOffline() === OFFLINE_YES){
            $.artDialog.alert("系统未联网或没有外设源！请联网或插入外设源后再尝试安装。");
        }else {
             //alert(object.parents("li").html());
            //点下按钮的时候，在button上做一个记录
            if(!object.parents("li").hasClass("continueDownload")){
                object.parents("li").addClass("continueDownload");
            }
            if(object.hasClass("upgrade")){
                upgradeSoftware(object.parents("li").attr("software"), object.parents("li").attr("cversion"));
            }else if(object.hasClass("remove")){
                removeSoftware(object.parents("li").attr("software"), object.parents("li").attr("cversion"));
            }
            else{
                continueDownloading(object.parents("li").attr("software"), object.parents("li").attr("cversion"));
            }
        }


    }
}

function img_error(object){
    object.attr("src", "../data/images/default.png");
}

function hideAPTTask_small_click(object){
    hideAPTTask_small();
}

function showAPTTask_page_click(object){
    showAPTTask_page();
}

/**
  搜索功能
*/
function searchLocalSoftwares(keyword){
    if($(".showRecommendISoftwares").length
            || $(".showISoftwares").length
            || $(".showSoftware").length
            || $(".showAPTTasks").length){
        window.location.href = "./list_softwares_new.html?keyword=" + keyword;
    }else if($(".showRemoveSoftwares").length){
        window.location.href = "./list_removesoftwares.html?keyword=" + keyword;
    }else if($(".showUpgradeSoftwares").length){
        window.location.href = "./list_upgradesoftwares.html?keyword=" + keyword;
    }
}

function showSoftCategories(softCategories){
    var totalCount = 0;
    for(var index in softCategories){
        var html_str = "";

        html_str += "<li id='softCategoryID_" + softCategories[index].id + "' class='icon_" + softCategories[index].id + "'>"
                + "<a href='list_softwares.html?categoryId=" + softCategories[index].id + "'>"
                + softCategories[index].title + "(" + softCategories[index].count + ")"
                + "</a>"
                + "</li>";

        $(".showSoftCategories").after(html_str);
        totalCount += parseInt(softCategories[index].count);
    }
    $(".showSoftCategories").after("<li id='softCategoryID_' class='icon_' ><a href='list_softwares.html?categoryId=-1'>所有软件(" + totalCount + ")</a></li>");
}

function showSoftCategory(softCategory){
    $("#subc").text(softCategory.title);
}

function showRecommendISoftwares(isoftwares){
    for(var index in isoftwares){
        var html_str = "";

        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;

        var software = isoftwares[index].software;
        var title = isoftwares[index].title;
        title = $.textCut(title, 14, true, "...");
        var cversion = isoftwares[index].cversion;
        cversion = $.textCut(cversion, 12, true, "...");
        var short_desc = isoftwares[index].short_desc;
        //short_desc = short_desc.length > 26 ? $.trim(short_desc).substring(0, 26) + "..." : short_desc;
        short_desc = $.textCut(short_desc, 26, true, "...");
        var average = $.averageScore(isoftwares[index].score, isoftwares[index].ratercount);

        html_str += "<li id='" + software + "'>"
                + "<img src='../data/images/" + software + "/icon' />"
                + "<h3><a href='javascript:_viewSoftware(\""+software+"\")'>" + title + "</a></h3>"
                + "<span>"+$.textCut(decodeURIComponent(isoftwares[index].ctitle), 14,true)+"</span>"
                + "<p><a btype='install' class='btn_comm btn03 installSoftware'";
        
        html_str += " software='" + software + "'"
                + " cversion='" + isoftwares[index].cversion + "'"
                + " packageName='" + software + "'"
                + " nv='" + isoftwares[index].cversion + "'"
                + " >安装</a>"
                + "</p>"
                + "</li>";

        $(".showRecommendISoftwares").append(html_str);
    }
}

function showTopISoftwares(isoftwares){
    for(var index in isoftwares){
        var html_str = "";

        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;

        var software = isoftwares[index].software;
        var title = isoftwares[index].title;
        title = $.textCut(title, 10, true, "...");
        var cversion = isoftwares[index].cversion;
        cversion = $.textCut(cversion, 12, true, "...");
        var short_desc = isoftwares[index].short_desc;
        //short_desc = short_desc.length > 26 ? $.trim(short_desc).substring(0, 26) + "..." : short_desc;
        short_desc = $.textCut(short_desc, 26, true, "...");
        var average = $.averageScore(isoftwares[index].score, isoftwares[index].ratercount);

        html_str += "<li id='" + software + "'>";
        if(index < 3){
            html_str += "<span class='num_p top_red'>";
        }else{
            html_str += "<span class='num_p'>";
        }
        html_str += (parseInt(index) + 1)
                + "</span>"
                + "<a href='javascript:_viewSoftware(\""+software+"\")' class='img_link'>"
                //+ "<a href='view_software.html?software=" + software + "' class='img_link'>"
                + "<img src='../data/images/" + software + "/icon' />"
                +  title
                + "</a>"
                + "</li>";
        $(".showTopISoftwares").append(html_str);
    }
}

/*
* showISoftwares函数用来显示软件列表
* */
function showISoftwares(isoftwares){
    for(var index in isoftwares){
        var html_str = "";

        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;

        var software = isoftwares[index].software;
        var softwareStatus = isoftwares[index].softwareStatus;
        var title = isoftwares[index].title;
        title = $.textCut(title, 20, true, "...");
        var cversion = isoftwares[index].cversion;
        cversion = $.textCut(cversion, 15, true, "...");
        var short_desc = isoftwares[index].short_desc;
        //short_desc = short_desc.length > 26 ? $.trim(short_desc).substring(0, 26) + "..." : short_desc;
        short_desc = $.textCut(short_desc, 26, true, "...");
        var average = $.averageScore(isoftwares[index].score, isoftwares[index].ratercount);

        html_str += "<tr id='" + software + "'>"
                + "<td style='text-align:left'>"
                + "<a href='javascript:_viewSoftware(\""+software+"\")'>"
                + "<span class='fl_img' title='" + isoftwares[index].short_desc + "'><img src='../data/images/" + software + "/icon' /></span>"
                + title
                + "</a>";
        if(isoftwares[index].recommend === RECOMMEND_YES){
            //html_str += "<img src='images/tj.png' style='margin-left:5px' />";    //样式不能正确显示
        }
        html_str += "</td>"
                //+ "<td class='short_desc'>" + short_desc + "<a href='javascript:_viewSoftware(\""+software+"\")' class='link_see'>详细</a></td>"
                + "<td>" + $.convertFromkb(isoftwares[index].size) + "</td>"
                + "<td>" + cversion + "</td>"
                + "<td>";
        html_str += "<div class='star_bg'><span style='width:" + average*10 + "%' title='" + average + " 分 '></span></div>";
        html_str += "</td>";
        //html_str += "<td colspan='2' class='changeProgress'><div class='bar_w'></div></td>";
        //html_str += "<td class='presenter'>" + isoftwares[index].presenter + "</td>";
        //html_str += "<td class='auditor'>" + isoftwares[index].auditor + "</td>";
        html_str += "<td style='text-align:center;'>"
                + "<input type='button' btype='install' ";
        if(isoftwares[index].softwareStatus === STATUS_CAN_BE_INSTALLED){
            html_str += " value='安装' class='btn_comm btn03 installSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_INSTALLING){
            html_str += " value='正在安装' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_INSTALLED){
			if(!!isoftwares[index].method && isoftwares[index].method == 2){
				html_str += " value='打开' class='btn_comm  btn01 openSoftware '";
			}else{
				html_str += " value='已安装' class='btn_comm  btn01 disabled' disabled='true'";
			}
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_REMOVED){
            html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_REMOVING){
            html_str += " value='正在卸载' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_REMOVED){
            html_str += " value='已卸载' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADE_FAILED){
            html_str += " value='错误' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_UPGRADED){
            html_str += " value='升级' class='btn_comm btn03 upgradeSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADING){
            html_str += " value='正在升级' class='btn_comm btn03 disabled upgradeSoftware' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADED){
            html_str += " value='已升级' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_CANCEL){
            if(APT_CANCEL_STATUS === "yes"){
                html_str += " value='取消' class='btn_comm cancelAPTTask'";
            }else {
                html_str += " value='取消' class='btn_comm disabled' disabled='true'";
            }
        }else if(isoftwares[index].softwareStatus === STATUS_CANCELING){
            html_str += " value='正在取消' class='btn_comm disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CANCELED){
            html_str += " value='已取消' class='btn_comm disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_PAUSE){
            if(APT_PAUSE_STATUS === "yes"){
                html_str += " value='暂停' class='btn_comm btn03 pauseAPTTask'";
            }else {
                html_str += " value='暂停' class='btn_comm btn03 disabled' disabled='true'";
            }
        }else if(isoftwares[index].softwareStatus === STATUS_PAUSING){
            html_str += " value='正在暂停' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_PAUSED){
            html_str += " value='继续' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_DOWNLOADING){
            html_str += " value='正在下载' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_DOWNLOADFAILD){
            html_str += " value='下载失败' class='btn_comm btn03 disabled' disabled='true'";
        }
        html_str += " software='" + software + "'"
                + " cversion='" + isoftwares[index].cversion + "'"
                + " packageName='" + software + "'"
                + " nv='" + isoftwares[index].cversion + "'"
                + " />";
        html_str += "<div class='changeProgress'><div class='bar_w'></div></div>"
                + "</td>";
        html_str += "<td class='changeAptExecType'></td>"
                + "</tr>";
        $(".showISoftwares").append(html_str);

        if(softwareStatus === STATUS_INSTALLING || softwareStatus === STATUS_REMOVING
                || softwareStatus === STATUS_UPGRADING){
            $(".showISoftwares [id='" + software + "'] .changeProgress").show();
            //$(".showISoftwares [id='" + software + "'] .presenter").hide();
            //$(".showISoftwares [id='" + software + "'] .auditor").hide();
            //$(".showISoftwares [id='" + software + "'] .star_bg").hide();
            $(".showISoftwares [id='" + software + "'] .btn_comm").hide();
            $(".showISoftwares [id='" + software + "'] .changeAptExecType").empty().append("执行中");
        }else{
            $(".showISoftwares [id='" + software + "'] .changeProgress").hide();
            //$(".showISoftwares [id='" + software + "'] .presenter").show();
            //$(".showISoftwares [id='" + software + "'] .auditor").show();
            //$(".showISoftwares [id='" + software + "'] .star_bg").show();
            $(".showISoftwares [id='" + software + "'] .btn_comm").show();
            $(".showISoftwares [id='" + software + "'] .changeAptExecType").empty();
        }
    }
}

function showSoftware(isoftwares){
    for(var index in isoftwares){
        var html_str = "";

        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;

        var software = isoftwares[index].software;
        var title = isoftwares[index].title;
        //title = $.textCut(title, 18, true, "...");
        var cversion = isoftwares[index].cversion;
        cversion = $.textCut(cversion, 12, true, "...");
        var short_desc = isoftwares[index].short_desc;
        //short_desc = short_desc.length > 26 ? $.trim(short_desc).substring(0, 26) + "..." : short_desc;
        short_desc = $.textCut(short_desc, 26, true, "...");
        var average = $.averageScore(isoftwares[index].score, isoftwares[index].ratercount);
        var totalDownloadedCount = isoftwares[index].totalDownloadedCount;
        var origin = isoftwares[index].origin;
        var homepage = isoftwares[index].homepage;
        homepage = $.textCut(homepage, 20, true, "...");
        var long_desc = isoftwares[index].long_desc;
        html_str += "<div class='cont_l' id='" + software + "'>"
                + "<p class='cont_logo'><img src='../data/images/" + software + "/icon' /></p>"
                + "<h3>" + title + "</h3>"
                + "<p class='cont_star'>平均评分：<span id='average_score' class='font_p2'>" + average + "</span></p>"
                + "<p class='cont_star'>点击评分：<span id='star' style='display:inline-block;'></span></p>"
                + "<p class='tc'>"
                + "<input type='button' btype='install' ";
        if(isoftwares[index].softwareStatus === STATUS_CAN_BE_INSTALLED){
            html_str += " value='下载' class='btn_comm btn03 installSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_INSTALLING){
            html_str += " value='正在安装' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_INSTALLED){
			if(!!isoftwares[index].method && isoftwares[index].method == 2){
				html_str += " value='打开' class='btn_comm  btn01 openSoftware '";
			}else{
				html_str += " value='已安装' class='btn_comm  btn01 disabled' disabled='true'";
			}
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_REMOVED){
            html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_REMOVING){
            html_str += " value='正在卸载' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_REMOVED){
            html_str += " value='已卸载' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADE_FAILED){
            html_str += " value='错误' class='btn_comm btn02 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_UPGRADED){
            html_str += " value='升级' class='btn_comm  btn_upgrade btn03 upgradeSoftware'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADING){
            html_str += " value='正在升级' class='btn_comm btn_upgrade btn03 disabled upgradeSoftware' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_UPGRADED){
            html_str += " value='已升级' class='btn_comm btn_upgrade btn03 disabled upgradeSoftware' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_CANCEL){
            if(APT_CANCEL_STATUS === "yes"){
                html_str += " value='取消' class='btn_comm cancelAPTTask'";
            }else {
                html_str += " value='取消' class='btn_comm disabled' disabled='true'";
            }
        }else if(isoftwares[index].softwareStatus === STATUS_CANCELING){
            html_str += " value='正在取消' class='btn_comm disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CANCELED){
            html_str += " value='已取消' class='btn_comm disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_CAN_BE_PAUSE){
            if(APT_PAUSE_STATUS === "yes"){
                html_str += " value='暂停' class='btn_comm btn03 pauseAPTTask'";
            }else {
                html_str += " value='暂停' class='btn_comm btn03 disabled' disabled='true'";
            }
        }else if(isoftwares[index].softwareStatus === STATUS_PAUSING){
            html_str += " value='正在暂停' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_PAUSED){
            html_str += " value='继续' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_DOWNLOADING){
            html_str += " value='正在下载' class='btn_comm btn03 disabled' disabled='true'";
        }else if(isoftwares[index].softwareStatus === STATUS_DOWNLOADFAILD){
            html_str += " value='下载失败' class='btn_comm btn03 disabled' disabled='true'";
        }
        html_str += " software='" + software + "'"
                + " cversion='" + isoftwares[index].cversion + "'"
                + " packageName='" + software + "'"
                + " nv='" + isoftwares[index].cversion + "'"
                + " />"
                + "</p>"
                + "<ul class='cont_info'>"
                + "<li>最新版本：" + cversion + "</li>"
                + "<li>大小：" + $.convertFromkb(isoftwares[index].size) + "</li>"
                + "<li>下载：" + totalDownloadedCount + "</li>"
                + "<li>来源：" + origin + "</li>"
                + "<li>软件主页:</li>"
                + "<li><a href='#'>" + homepage + "</a></li>"
                + "</ul>"
                + "</div>";

         var right_html = " <div id='div_height'>"
                + "<dl class='cont_d'>"
                + "<dt>软件介绍</dt>"
                + "<dd>"
                + long_desc
                + "</dd>"
//                + "<dt>推荐信息</dt>"
//                + "<dd>"
//                + "<table class='table_p'>"
//                + "<tbody>"
//                + "<tr>"
//                + "<td valign='top' width='50px'><b>推荐人</b></td>"
//                + "<td><img src='images/default_per.png' width='30px' height='30px' />" + isoftwares[index].presenter + "<span class='font_p'></span>"
//                + "<p>" + isoftwares[index].presentercomment + "</p>"
//                + "</td>"
//                + "</tr>"
//                + "<tr>"
//                + "<td valign='top'><b>审批人</b></td>"
//                + "<td><img src='images/default_per.png' width='30px' height='30px' />" + isoftwares[index].auditor + "<span class='font_p'></span></td>"
//                + "</tr>"
//                + "</tbody>"
//                + "</table>"
//                + "</dd>"
                +"<dt>用户评论<span style='color:red;'id='comment_count'>0</span>条</dt>"
                +"<dd>"
                +"<input type='hidden' value=\"<s:property value='software.software'/>\" id='apppkgname'/>"
                +"<input type='hidden' value=\"<s:property value='software.id'/>\" id='appuuid'/>"
                +"<table class='table_p' id='comments'>"
                +"<tbody>"
                +"</tbody>"
                +"</table>"
                +"<div id='pagination'></div>"               
                +"<h3>发表评论</h3>"
                +"<table class='table_p' id='addcomment' style='width: 100%''>"
                +"<tbody>"
                +"<tr>"
                +"<td id='comment_error' style='color: red;'>"
                +"</td>"
                +"</tr>"
                +"<tr style='width: 80%'>"
                +"<td>"
                +"<textarea style='width:100%;height:72px;border: 1px;border-style: solid;border-color: green;overflow-x: hidden;overflow-y: auto;resize: vertical;' id='comment' onkeyup='checkLength(this)'; onmouseup='onRightClick(event)'; ></textarea>"
                +"<span class='wordage'>剩余字数：<span id='sy' style='color:Red;'>512</span></span>"
                +"</td>"
                +"</tr>"
                +"<tr>"
                +"<td style='float: right;'>"
                +"<input type='button' value='提交' id='comment_submit' class='btn_comm btn01'/>"
                +"</td>"
                +"</tr>"
                +"</tbody>"
                +"</table>"
                +"<div style='clear: both;''></div>"
                +"</dd>"
                + "</dl>"
                +"</div>";
        $(".showSoftware").html(html_str);
        $("#right_html").html(right_html);
    }
}

/*
* 任务栏显示与状态更新
* */
function showAPTTasks_small(isoftwares){
    var isEXEC = false;
    var flag = false;
    //var cancel for remove apttask
    for(var index in isoftwares){
        var html_str = "";
        var software = isoftwares[index].software;
        if(software === "add_repository" || software === "update" || software===""){
            return; //添加源或更新源 不显示任务
        }
        var softwareStatus = isoftwares[index].softwareStatus;

        var APT_CMD = isoftwares[index].APT_CMD;
        var APT_EXEC_STATUS = isoftwares[index].APT_EXEC_STATUS;
        var BYTES_DONE = isoftwares[index].BYTES_DONE;
        var BYTES_TOTAL = isoftwares[index].BYTES_TOTAL;
        var SPEED = isoftwares[index].SPEED;
        var PROGRESS = isoftwares[index].PROGRESS;
        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;
        var ERR_MSG=isoftwares[index].ERROR_MSG;

        var apt_exec_type = getAPTExecType(isoftwares[index]);

        if(APT_CMD === "install" && PROGRESS > 0){
            PROGRESS = (PROGRESS-50)*2;
        }

        //用户取消授权或安装成功，移除任务栏
        //用户下载过程中，取消任务成功，移除任务栏
	    if(APT_EXEC_STATUS === "notAuthorized" || APT_EXEC_STATUS === "success" ||(APT_EXEC_STATUS === "cancel" && softwareStatus === STATUS_DOWNLOADING)){
            $(".showAPTTasks_small li[id='"+software+"']").remove();
            flag = true;
            return;
	    }

        if(softwareStatus!==STATUS_DOWNLOADING){
//            PROGRESS = calcProgress(isoftwares[index]);
        }else{
            PROGRESS = isoftwares[index].PROGRESS;
            SPEED = isoftwares[index].SPEED+ " B/S";
        }

        if( SPEED === ""){//###BYTES_DONE === "" || BYTES_TOTAL === "" ||
//            BYTES_DONE = "0 B";
//            BYTES_TOTAL = "0 B";
            SPEED = "0 B/s";
        }
        if(BYTES_DONE === ""){
            BYTES_DONE = "0 B";
        }
        if(apt_exec_type !== "等待" && apt_exec_type !== "等待中"
                && apt_exec_type !== "下载中"){
            BYTES_DONE = $.convertFromkb(isoftwares[index].size);
            BYTES_TOTAL = $.convertFromkb(isoftwares[index].size);
            SPEED = "";
        }

        if(softwareStatus !== STATUS_INSTALLED && softwareStatus !== STATUS_REMOVED
                && softwareStatus !== STATUS_UPGRADE_FAILED
                && softwareStatus !== STATUS_UPGRADED
                && softwareStatus !== STATUS_CANCELED){
            var title = isoftwares[index].title;
            title = $.textCut(title, 18, true, "...");
	        var error_s = "";
            if(APT_EXEC_STATUS && (APT_EXEC_STATUS === "downloadFailed" || APT_EXEC_STATUS === "failed")){
                error_s = " class='error' ";
            }

            html_str += "<li id='" + software + "'>"
                    + "<span class='fl_img'><img src='../data/images/" + software + "/icon' /></span>"
                    + "<div class='progress'>"
                    + "<p>" + title + "<span style='font-weight: normal;font-size: 12px;'> - " + apt_exec_type + "</span></p>"
                    + "<div class='bar_w'>";

            if(PROGRESS > 0 && PROGRESS <= 100){
                html_str += "<span style='width:" + PROGRESS + "%' " + error_s + "></span>";
                html_str += "<div>" + BYTES_DONE;
                if(SPEED !== ""){
                    html_str += " - " + SPEED;
                }
                html_str += "</div>"
            }else {
                   var _vv = $(".showAPTTasks_small li[id='" + software + "']").find(".bar_w").html();
                   if(typeof(_vv) == "undefined"){
                    html_str += "<span style='width:" + PROGRESS + "%' " + error_s + "></span>";
                   }else{
                    html_str += _vv;
                   }
            }

            html_str += "</div>";
            html_str += "<input type='submit'";

            if(APT_EXEC_STATUS === "pending"){
                if(APT_CMD === "install"){
                    html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
                }else if(APT_CMD === "remove"){
                    html_str += " value='||' class='btn_comm btn_pause pauseAPTTask  removeSoftware'";
                }else if(APT_CMD === "upgrade"){
                    html_str += " value='||' class='btn_comm btn_pause pauseAPTTask  upgradeSoftware'";
                }else{
                    html_str += " value='||' class='btn_comm btn_pause pauseAPTTask'";
		        }
            }else if(APT_EXEC_STATUS==="waitDownloading"){
                html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
            }else if(APT_EXEC_STATUS==="downloading"){
                html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
            }else if(APT_EXEC_STATUS==="waitInstall"){
//                html_str += "  class=' installSoftware'";
                if(softwareStatus === STATUS_WAITINGAUTHORIZATION){
                        html_str += " value='||' class='btn_comm btn_pause disabled installSoftware' disabled='true'";
                }else{
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
                }

            }else if(APT_EXEC_STATUS === "downloadFailed" || APT_EXEC_STATUS === "paused"){
                if(APT_CMD === "install"){
                    html_str += " value='►' class='btn_comm  btn_continue installSoftware'";
                }else if(APT_CMD === "remove"){
                    html_str += " value='►' class='btn_comm  btn_continue removeSoftware'";
                }else if(APT_CMD === "upgrade"){
                    html_str += " value='►' class='btn_comm  btn_continue upgradeSoftware'";
                }else if(APT_CMD === "download"){
                    html_str += " value='►' class='btn_comm  btn_continue continueInstallSoftware'";
                }
            }else{
                if(softwareStatus === STATUS_CAN_BE_INSTALLED){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_INSTALLING){
                    if(APT_PAUSE_STATUS === "yes" && APT_EXEC_STATUS!="inprogress"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask installSoftware'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_WAITINGAUTHORIZATION){
                    html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                }else if(softwareStatus === STATUS_INSTALLED){

                }else if(softwareStatus === STATUS_CAN_BE_REMOVED){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask removeSoftware'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled ' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_REMOVING){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask removeSoftware'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_REMOVED){

                }else if(softwareStatus === STATUS_UPGRADE_FAILED){

                }else if(softwareStatus === STATUS_CAN_BE_UPGRADED){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask upgradeSoftware'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_UPGRADING){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask  disabled' disabled='true'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_UPGRADED){

                }else if(softwareStatus === STATUS_CAN_BE_CANCEL){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_CANCELING){
                    html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                }else if(softwareStatus === STATUS_CANCELED){
                    html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                }else if(softwareStatus === STATUS_CAN_BE_PAUSE){
                    if(APT_PAUSE_STATUS === "yes"){
                        html_str += " value='||' class='btn_comm btn_pause pauseAPTTask'";
                    }else {
                        html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_PAUSING){
                    html_str += " value='||' class='btn_comm btn_pause disabled' disabled='true'";
                }else if(softwareStatus === STATUS_PAUSED){

                    if(isEXEC){
                        if(APT_CMD === "install"){
                            html_str += " value='||' class='btn_comm btn_pause  disabled installSoftware' disabled='true'";
                        }else if(APT_CMD === "remove"){
                            html_str += " value='||' class='btn_comm btn_pause  disabled removeSoftware' disabled='true'";
                        }else if(APT_CMD === "upgrade"){
                            html_str += " value='||' class='btn_comm btn_pause  disabled upgradeSoftware' disabled='true'";
                        }else if(APT_CMD === "download"){
                            html_str += " value='||' class='btn_comm btn_pause  disabled installSoftware' disabled='true'";
                        }
                    }else{
                        if(APT_CMD === "install"){
                            html_str += " value='►' class='btn_comm btn_continue installSoftware'";
                        }else if(APT_CMD === "remove"){
                            html_str += " value='►' class='btn_comm btn_continue  removeSoftware'";
                        }else if(APT_CMD === "upgrade"){
                            html_str += " value='►' class='btn_comm btn_continue  upgradeSoftware'";
                        }else if(APT_CMD === "download"){
                            html_str += " value='►' class='btn_comm btn_continue  installSoftware'";
                        }
                    }
                }
            }
            html_str += " software='" + software + "'"
                    + " cversion='" + isoftwares[index].cversion + "'"
                    + " packageName='" + software + "'"
                    + " cv='" + isoftwares[index].cversion + "'"
            //        + " title='" + isoftwares[index].title + "'"
                    + " sys='" + isoftwares[index].isSys + "'"
                    + " nv='" + isoftwares[index].cversion + "'"
                    + " />"
                    + "<input type='submit'";
            if(APT_EXEC_STATUS === "pending"){
                html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
            }else if(APT_EXEC_STATUS === "waitDownloading"|| APT_EXEC_STATUS === "downloading"){
                html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
            }else if(APT_EXEC_STATUS === "waitInstall"){
                if(softwareStatus === STATUS_WAITINGAUTHORIZATION){
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                }else{
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                }

            }else if(APT_EXEC_STATUS === "downloadFailed" || APT_EXEC_STATUS === "failed"){
					 html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
				}else if(APT_EXEC_STATUS === "paused"){
                if(softwareStatus === STATUS_PAUSED){
                    html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                }else if(softwareStatus === STATUS_DOWNLOADING){
                    html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                }
            }else{
//                alert(isEXEC+"    "+APT_CMD+"   "+APT_EXEC_STATUS);
                if(softwareStatus === STATUS_CAN_BE_INSTALLED){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_INSTALLING){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask disabled' disabled='true'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_INSTALLED){

                }else if(softwareStatus === STATUS_WAITINGAUTHORIZATION){
                    html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                }else if(softwareStatus === STATUS_CAN_BE_REMOVED){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_REMOVING){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask disabled' disabled='true'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_REMOVED){

                }else if(softwareStatus === STATUS_UPGRADE_FAILED){

                }else if(softwareStatus === STATUS_CAN_BE_UPGRADED){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_UPGRADING){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask disabled' disabled='true'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_UPGRADED){

                }else if(softwareStatus === STATUS_CAN_BE_CANCEL){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_CANCELING){
                    html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                }else if(softwareStatus === STATUS_CANCELED){
                    html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                }else if(softwareStatus === STATUS_CAN_BE_PAUSE){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }else if(softwareStatus === STATUS_PAUSING){
                    html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                }else if(softwareStatus === STATUS_PAUSED){
                    if(APT_CANCEL_STATUS === "yes"){
                        html_str += " value='×' class='btn_comm btn_cancel cancelAPTTask'";
                    }else {
                        html_str += " value='×' class='btn_comm btn_cancel disabled' disabled='true'";
                    }
                }
            }
            html_str += " software='" + software + "'"
                    + " cversion='" + isoftwares[index].cversion + "'"
                    + " />";
            html_str += "</div>"
                    + "</li>";
        }
        if($(".showAPTTasks_small").has("[id='" + software + "']").length){
            $(".showAPTTasks_small li[id='" + software + "']").replaceWith(html_str);
        }else {
            $(".showAPTTasks_small").append(html_str);
        }

    }
}

/**
  *  任务栏更新显示，重写
  */
function showAPTTasks_small_new(isoftwares){
     for(var index in isoftwares){

         var software = isoftwares[index].software;
         var softwareStatus = isoftwares[index].softwareStatus;
         var APT_CMD = isoftwares[index].APT_CMD;
         var APT_EXEC_STATUS = isoftwares[index].APT_EXEC_STATUS;
         var BYTES_DONE = isoftwares[index].BYTES_DONE;
         var BYTES_TOTAL = isoftwares[index].BYTES_TOTAL;
         var SPEED = isoftwares[index].SPEED;
         var PROGRESS = isoftwares[index].PROGRESS;
         var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
         var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;
         var ERR_MSG=isoftwares[index].ERROR_MSG;
         var apt_exec_type = getAPTExecType(isoftwares[index]);
         var software_size = $.convertFromkb(isoftwares[index].size);
         var title = isoftwares[index].title;
         title = $.textCut(title, 18, true, "...");
         var cversion = isoftwares[index].cversion;
         var method = isoftwares[index].method;
         var _imagePath ="";
         var _html ="";
         log(APT_CMD + "   " + softwareStatus + "   " + APT_EXEC_STATUS + "   "+apt_exec_type + "    " + PROGRESS + "  ===  " + method);
         /***************************************涉及到安装**********************************************************/
         //下载 等待下载
         //log(PROGRESS == "-1");
         if(APT_CMD ==="download" && softwareStatus === STATUS_WAITDOWNLOAD && APT_EXEC_STATUS ==="waitDownloading" && apt_exec_type === "等待下载" && PROGRESS == "-1"){
                 //然后判断当前是否存在这个对象,若不存在的话，那么在管理窗口中加入
                  if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                      _imagePath = '../data/images/' + software +'/icon';
                      _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                      _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                      _html += '<div class="progress">';
                      _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ apt_exec_type +'</span></p>';
                      _html += '<div class="bar_w">';
                      _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                      _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                      _html += '</div>';
                      _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask download" />';
                      _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask download" style="display:none"/>';
                      _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask download"/>';
                      _html += '</div>';
                      _html +=' </li>';
                     $(".showAPTTasks_small").append(_html);
                  }else{
                      if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hasClass("download")){
                          $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("download");
                      }
                      if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hasClass("download")){
                          $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").addClass("download");
                      }
                      $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show();
                      $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                      $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ apt_exec_type );
                      if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                             $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                      }
                      $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
                  }
         //正在下载
         }else if(APT_CMD === "download" && softwareStatus === STATUS_DOWNLOADING && APT_EXEC_STATUS==="downloading" && apt_exec_type === "正在下载"){   //正在下载
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +"/icon";
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ apt_exec_type +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask"/>';
                 _html +=' </li>';
                  $(".showAPTTasks_small").append(_html);
             }else{
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show();
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                  $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ apt_exec_type );
                  $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
             }
         }else if(APT_CMD === "download" && softwareStatus === STATUS_DOWNLOADING && APT_EXEC_STATUS==="paused"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +"/icon";
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ apt_exec_type +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" />';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask"/>';
                 _html +=' </li>';
                  $(".showAPTTasks_small").append(_html);
             }else{
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hide();
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").show();
                  $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ apt_exec_type );
                  $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
             }
         }else if(softwareStatus === STATUS_DOWNLOADING && APT_EXEC_STATUS==="cancel"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                 $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
         }
         else if(APT_CMD === "install" && softwareStatus === STATUS_WAITINGAUTHORIZATION && APT_EXEC_STATUS === "installing" && apt_exec_type=== "正在安装" && PROGRESS === -1){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +"/icon";
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在安装' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask disabled" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask disabled"/>';
                 _html += '</div>';
                 _html +=' </li>';
                  $(".showAPTTasks_small").append(_html);
             }else{
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("disabled");
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").addClass("disabled");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '正在安装' );
                  $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         //正在安装模式 -1 等待验证权限
         else if(APT_CMD === "install" && softwareStatus === STATUS_INSTALLING && APT_EXEC_STATUS === "installing"){    //正在安装
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +"/icon";
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 if(PROGRESS === -1){
                      _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '等待安装' +'</span></p>';
                 }else{
                     _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ apt_exec_type +'</span></p>';
                 }

                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask disabled" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask disabled"/>';
                 _html += '</div>';
                 _html +=' </li>';
                  $(".showAPTTasks_small").append(_html);
             }else{
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("disabled");
                  $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").addClass("disabled");
                  if(PROGRESS === -1){
                     $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '等待安装' );
                  }else{
                     $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ apt_exec_type );
                  }


                  $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }else if(APT_CMD === "install" && softwareStatus === STATUS_INSTALLING && APT_EXEC_STATUS === "inprogress"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +"/icon";
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
		 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask">' + software +' - '+ apt_exec_type +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask"/>';
                 _html += '</div>';
                 _html +=' </li>';
                  $(".showAPTTasks_small").append(_html);
             }else{
		   $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(software + ' - '+ apt_exec_type );
                  $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                  $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         else if(softwareStatus === STATUS_CAN_BE_INSTALLED && APT_EXEC_STATUS === "notAuthorized"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                 $(".showAPTTasks_small li[id='"+software+"']").remove();
             }

         }else if( APT_CMD ==="install" &&softwareStatus === STATUS_INSTALLED && APT_EXEC_STATUS === "success"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
            if($(".showAPTTasks_small li").size() == 0)
            {
                hideAPTTask_small();
            }
         }else if(softwareStatus === STATUS_CANCELED && APT_EXEC_STATUS ==="success"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
            if($(".showAPTTasks_small li").size() == 0)
            {
                hideAPTTask_small();
            }
         }
         //升级模式 等待状态
         else if(softwareStatus === STATUS_UPGRADING && APT_EXEC_STATUS === "pending"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '等待升级' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask upgrade" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 //如果没有upgrade class则添加
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hasClass("upgrade")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("upgrade");
                 }
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hasClass("upgrade")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").addClass("upgrade");
                 }
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '等待升级' );
          //       if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
            //     }
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
             }
         }
         else if(softwareStatus === STATUS_UPGRADING && APT_EXEC_STATUS === "inprogress" && apt_exec_type === "等待中"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在升级' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '正在升级' );
         //        if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
           //      }
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
             }
         }else if(softwareStatus === STATUS_UPGRADING && APT_EXEC_STATUS === "inprogress" && (apt_exec_type === "下载中" || apt_exec_type === "升级中")){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在升级' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask" disabled/>';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask disabled"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '正在升级' );
           //      if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
             //    }
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size+' - '+ SPEED + 'kb/s');
             }
         }else if(softwareStatus === STATUS_UPGRADED && APT_EXEC_STATUS === "success"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
         }
         //升级模式 暂停
         else if(APT_CMD === "upgrade" && softwareStatus === STATUS_PAUSED && APT_EXEC_STATUS === "paused"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在升级' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +' - 0kb/s</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask upgrade" style="display:none"/>';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask upgrade" />';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask "/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hasClass("upgrade")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("upgrade");
                 }
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hasClass("upgrade")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").addClass("upgrade");
                 }
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").show();
                 $(".showAPTTasks_small li[id='"+software+"']").addClass("continueDownload");
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '暂停' );
             }
         }

           //升级模式，点击了取消按钮
         else if(softwareStatus === STATUS_CAN_BE_UPGRADED && APT_EXEC_STATUS === "success"){

             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){

                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
         }
         //软件卸载模式 等待卸载
         else if(APT_CMD === "remove" && softwareStatus === STATUS_REMOVING && APT_EXEC_STATUS === "pending" && apt_exec_type === "等待"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '等待卸载' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size+'</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask remove" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask remove" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask remove"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - ' + '等待卸载' );
                 if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                 }
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         //卸载模式 开始卸载
         else if(APT_CMD === "remove" && softwareStatus === STATUS_REMOVING && APT_EXEC_STATUS === "inprogress" && apt_exec_type === "等待中"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在卸载' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +'</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask remove disabled" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask remove disabled" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask remove disabled"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '正在卸载' );
                 log("=========================== > " + $(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload"));
                 if(!$(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                 }
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         //卸载，暂停
         else if(APT_CMD === "remove" &&  softwareStatus === STATUS_PAUSED && APT_EXEC_STATUS === "paused"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在升级' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +'</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask remove" style="display:none"/>';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask remove" />';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask "/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hasClass("remove")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").addClass("remove");
                 }
                 if(!$(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hasClass("remove")){
                             $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").addClass("remove");
                 }
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").show();
                 $(".showAPTTasks_small li[id='"+software+"']").addClass("continueDownload");
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '暂停' );
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         else if(APT_CMD === "remove" && softwareStatus === STATUS_REMOVING && APT_EXEC_STATUS === "inprogress" && apt_exec_type === "卸载中"){
             if($(".showAPTTasks_small li[id='"+software+"']").length === 0){
                 _imagePath = '../data/images/' + software +'/icon';
                 _html = '<li id="'+software+'" software="'+software+'" cversion="'+cversion+'">';
                 _html += '<span class="fl_img"><img src="'+_imagePath+'"/></span>';
                 _html += '<div class="progress">';
                 _html += '<p>'+title+'<span style="font-weight: normal;font-size: 12px;" class="changeExecTypeTask"> - '+ '正在卸载' +'</span></p>';
                 _html += '<div class="bar_w">';
                 _html += '<span style="width:'+PROGRESS+'%" class="changeProgressTask"></span>';
                 _html += '<div class="changeDisplayInfoTask">' + software_size +'</div>';
                 _html += '</div>';
                 _html += '<input type="submit" value="||" class="btn_pause btn_comm pauseAPTTask remove disabled" />';
                 _html += '<input type="submit" value="►" class="btn_continue btn_comm continueDownloadAPTTask remove disabled" style="display:none"/>';
                 _html += '<input type="submit" value="×" class="btn_cancel btn_comm cancelAPTTask remove disabled"/>';
                 _html += '</div>';
                 _html +=' </li>';
                $(".showAPTTasks_small").append(_html);
             }else{
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_pause").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_continue").hide();
                 $(".showAPTTasks_small li[id='"+software+"'] .btn_cancel").show().addClass("disabled");
                 $(".showAPTTasks_small li[id='"+software+"'] .changeExecTypeTask").text(' - '+ '正在卸载' );
                 log("remove : 卸载中 进度=====>" + PROGRESS);
                 //if($(".showAPTTasks_small li[id='"+software+"']").hasClass("continueDownload")){
                        $(".showAPTTasks_small li[id='"+software+"'] .changeProgressTask").width(PROGRESS+"%");
                 //}
                 $(".showAPTTasks_small li[id='"+software+"'] .changeDisplayInfoTask").text(software_size);
             }
         }
         //卸载模式 取消授权
         else if(APT_CMD === "remove" && softwareStatus === STATUS_CAN_BE_REMOVED && APT_EXEC_STATUS === "notAuthorized"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){

                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
         }
         else if(APT_CMD === "remove" && softwareStatus === STATUS_REMOVED && APT_EXEC_STATUS === "success"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
            if($(".showAPTTasks_small li").size() == 0)
            {
                hideAPTTask_small();
            }
         }else if(APT_CMD === "cancel" && softwareStatus === STATUS_CAN_BE_REMOVED && APT_EXEC_STATUS === "success"){
             if($(".showAPTTasks_small li[id='"+software+"']").length > 0){
                  $(".showAPTTasks_small li[id='"+software+"']").remove();
             }
            if($(".showAPTTasks_small li").size() == 0)
            {
                hideAPTTask_small();
            }
         }

     }
}


function showRemoveSoftwares(softwares){
    var hasSoftwares = $(".showRemoveSoftwares tr").length;     //在循环前获取对应类型软件数量，确保正确顺序显示软件

    var remove_total_count = softwares.length;
    var free_space = "0M";
    var deb_count = 0;
    var less_count = 0;
    var recently_count = 0;

    for(var index in softwares){
        var html_str = "";
        var status = softwares[index].status;
        var packageName = softwares[index].packageName;

        if(status !== STATUS_REMOVED){
            var title = softwares[index].title;
            title = $.textCut(title, 18, true, "...");
            var short_desc = $._unescape(softwares[index].short_desc);
            short_desc = $.textCut(short_desc, 50, true, "...");
	    var softId = softwares[index].softwareid;
	    var softcategoryId = softwares[index].categoryId;
	    var packageInfo = new Array();
	    packageInfo[0]=packageName;
	    packageInfo[1]=softId;
	    packageInfo[2]=softcategoryId;
	    var isSystemPackage =  softwares[index].sys;
	    if(isSystemPackage == 1){
		    remove_total_count = remove_total_count - 1;
			continue;
	    }
            html_str += "<tr id='" + packageName + "'>"
                    //+ "<td><input type='checkbox' /></td>"
                    + "<td><span class='fl_img'><img src='../data/images/" + packageName+ "/icon' /></span>" + title + "</td>"
                 //   + "<td>" + short_desc + "<a href='javascript:_viewSoftware(\""+packageName+"\")' class='link_see'>详细</a></td>"
                    + "<td>" + short_desc + "<a href='javascript:_viewSoftware_New(\""+packageInfo+"\")' class='link_see'>详细</a></td>"
                    + "<td>" + $.convertFromkb(softwares[index].size) + "</td>"
                    + "<td>";
            html_str += "<div class='installedTime'>" + long2Date(softwares[index].installedTime) + "</div>";
            html_str += "</td>"
                    // + "<td>三月内</td>"
                    + "<td style='text-align:center;'>"
                    + "<input type='button'";
            if(softwares[index].status === STATUS_CAN_BE_INSTALLED){

            }else if(softwares[index].status === STATUS_INSTALLING){

            }else if(softwares[index].status === STATUS_INSTALLED){
                html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
            }else if(softwares[index].status === STATUS_CAN_BE_REMOVED){
                html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
            }else if(softwares[index].status === STATUS_REMOVING){
                html_str += " value='正在卸载' class='btn_comm btn02 disabled' disabled='true'";
            }else if(softwares[index].status === STATUS_REMOVED){
                html_str += " value='已卸载' class='btn_comm btn02 disabled' disabled='true'";
            }else if(softwares[index].status === STATUS_CAN_BE_UPGRADED){
                html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
            }else if(softwares[index].status === STATUS_UPGRADE_FAILED){
                html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
            }else if(softwares[index].status === STATUS_UPGRADING){

            }else if(softwares[index].status === STATUS_UPGRADED){
                html_str += " value='卸载' class='btn_comm btn02 removeSoftware'";
            }else if(softwares[index].status === STATUS_CAN_BE_CANCEL){

            }else if(softwares[index].status === STATUS_CANCELING){

            }else if(softwares[index].status === STATUS_CANCELED){

            }else if(softwares[index].status === STATUS_CAN_BE_PAUSE){

            }else if(softwares[index].status === STATUS_PAUSING){

            }else if(softwares[index].status === STATUS_PAUSED){

            }
            html_str += " packageName='" + packageName + "'"
                    + " cv='" + softwares[index].cv + "'"
                    + " title='" + softwares[index].title + "'"
                    + " sys='" + softwares[index].sys + "'"
                    + " />";
			if(!!softwares[index].method && softwares[index].method == 2){
				html_str += "  <input type='button' packageName='"+packageName+"' value='打开' class='btn_comm btn01 openSoftware'/>"
			}else{
				html_str += "  <input type='button' packageName='"+packageName+"' value='已安装' class='btn_comm btn01 disabled' disabled='true'/>";
			}
            //lulu add
            if(user_right == 2 || user_right == 7 || user_right == 15)
            {
                html_str += "<a style='font-size:13px;color:#fff;background-color:#ff731e;padding-top:4px;width:64px;height:20px;float:right;text-align:center;' name='feed_image_back' href='javascript:_feedback_info(\""+ packageInfo +"\")'>反馈</a>";
            }
            //end
            
            html_str += "<div class='changeProgress'><div class='bar_w'></div></div>";
            html_str += "</td>";
            html_str += "<td class='changeAptExecType'></td>"
                    + "</tr>";
        }

        if($(".showRemoveSoftwares").has("[id='" + packageName + "']").length){
            $(".showRemoveSoftwares [id='" + packageName + "']").replaceWith(html_str);
        }else {
            if(hasSoftwares){
                $(".showRemoveSoftwares").prepend(html_str);
            }else {
                $(".showRemoveSoftwares").append(html_str);
            }
        }

        if(status === STATUS_REMOVING){
            $(".showRemoveSoftwares [id='" + packageName + "'] .changeProgress").show();
            //$(".showRemoveSoftwares [id='" + packageName + "'] .installedTime").hide();
            $(".showRemoveSoftwares [id='" + packageName + "'] .btn_comm").hide();
            $(".showRemoveSoftwares [id='" + packageName + "'] .changeAptExecType").empty().append("执行中");
        }else{
            $(".showRemoveSoftwares [id='" + packageName + "'] .changeProgress").hide();
            //$(".showRemoveSoftwares [id='" + packageName + "'] .installedTime").show();
            $(".showRemoveSoftwares [id='" + packageName + "'] .btn_comm").show();
            $(".showRemoveSoftwares [id='" + packageName + "'] .changeAptExecType").empty();
        }

        $(".remove_total_count").text(remove_total_count);
        $(".free_space").text(free_space);
        $(".deb_count").text(deb_count);
        $(".less_count").text(less_count);
        $(".recently_count").text(recently_count);
    }
}

function showUpgradeSoftwares(softwares){
    var softwareType = "free";
    var hasSoftwares = $(".showUpgradeSoftwares." + softwareType + " tr").length;   //在循环前获取对应类型软件数量，确保正确顺序显示软件

    var upgrade_total_count = softwares.length; //分页数据的时候怎么取
   //by zhouchang
    if(upgrade_total_count == 0)
    {
        //0360767bugFix by LingJie
        document.getElementById("ignore_btn").style.cssText = "background:#BBBBBB";
        document.getElementById("ignore_btn").disabled = true;
        document.getElementById("recovery_btn").style.cssText = "background:#BBBBBB";
        document.getElementById("recovery_btn").disabled = true;
        document.getElementById("update_btn").style.cssText = "background:#BBBBBB";
        document.getElementById("update_btn").disabled = true;
        return;
    }
    var office_count = 0;
    var free_count = upgrade_total_count;
    var charge_count = 0;
    var test_count = 0;
    var canBeUpgraded_count = 0;
    var ignored_count = 0;

    for(var index in softwares){
        var html_str = "";
        var status = softwares[index].status;
        var packageName = softwares[index].packageName;
        var ignored = softwares[index].ignored;
        var record = softwares[index].record;

        if(status !== STATUS_UPGRADED){
            var title = softwares[index].title;
            title = $.textCut(title, 12, true, "...");
            var short_desc = softwares[index].short_desc;
            short_desc = $.textCut(short_desc, 35, true, "...");
            var cv = softwares[index].cv;
            cv = $.textCut(cv, 20, true, "...");
            var nv = softwares[index].nv;
            nv = $.textCut(nv, 20, true, "...");
	    var softId = softwares[index].softwareid;
	    var softcategoryId = softwares[index].categoryId;
	    var packageInfo = new Array();
	    packageInfo[0]=packageName;
	    packageInfo[1]=softId;
	    packageInfo[2]=softcategoryId;

            html_str += "<tr id='" + packageName + "'>"
                    //+ "<td width='4%'><input type='checkbox' /></td>"
                    + "<td width='20%'><span class='fl_img'><img src='../data/images/" +packageName+ "/icon' /></span>" + title + "</td>"
                    + "<td width='15%'>"
                    + short_desc;
            if(record === RECORD_YES){
                html_str += "<a href='javascript:_viewSoftware_New(\""+packageInfo+"\")' class='link_see'>详细</a>";
            }
            html_str += "</td>"
                    + "<td width='10%'>" + $.convertFromkb(softwares[index].size) + "</td>"
                    + "<td width='22%'>";
            html_str += "<div class='cv_nv'>已装：<span class='font_p'>" + cv + "</span>"
                    + "<p>最新：<span class='font_p'>" + nv + "</span></p></div>";
            html_str += "</td>"
                    // + "<td width='10%'>52%用户已升级</td>"
                    + "<td width='25%' style='text-align:center;'>"
                    + "<input type='button'";
            html_str += " value='恢复' class='btn_comm btn_recover recoverSoftware' style='background-color:#EEAD0E'"
            html_str += " packageName='" + packageName + "'"
                    + " nv='" + softwares[index].nv + "'"
                    + " />"
                    + "<input type='button'";
            if(softwares[index].status === STATUS_UPGRADING){
                html_str += " value='忽略' class='btn_comm btn_comm_ig btn_ignore disabled' disabled='true'"
            }else{
                html_str += " value='忽略' class='btn_comm btn_comm_ig btn_ignore ignoreSoftware'"
            }
            html_str += " packageName='" + packageName + "'"
                    + " nv='" + softwares[index].nv + "'"
                    + " />"
                    + "<input type='button'";
            if(softwares[index].status === STATUS_CAN_BE_INSTALLED){

            }else if(softwares[index].status === STATUS_INSTALLING){

            }else if(softwares[index].status === STATUS_INSTALLED){

            }else if(softwares[index].status === STATUS_CAN_BE_REMOVED){

            }else if(softwares[index].status === STATUS_REMOVING){

            }else if(softwares[index].status === STATUS_REMOVED){

            }else if(softwares[index].status === STATUS_CAN_BE_UPGRADED){
                html_str += " value='升级' class='btn_comm btn_upgrade btn04 upgradeSoftware'";
            }else if(softwares[index].status === STATUS_UPGRADING){
                html_str += " value='正在升级' class='btn_comm btn_upgrade btn04 disabled upgradeSoftware' disabled='true'";
            }else if(softwares[index].status === STATUS_UPGRADED){
                html_str += " value='已升级' class='btn_comm btn_upgrade btn04 disabled upgradeSoftware' disabled='true'";
            }else if(softwares[index].status === STATUS_CAN_BE_CANCEL){

            }else if(softwares[index].status === STATUS_CANCELING){

            }else if(softwares[index].status === STATUS_CANCELED){

            }else if(softwares[index].status === STATUS_CAN_BE_PAUSE){

            }else if(softwares[index].status === STATUS_PAUSING){

            }else if(softwares[index].status === STATUS_PAUSED){

            }
            html_str += " packageName='" + packageName + "'"
                    + " nv='" + softwares[index].nv + "'"
                    + " />";
            html_str += "<div class='changeProgress'><div class='bar_w'></div></div>"
                    + "</td>";
            html_str += "<td width='8%' class='changeAptExecType'></td>"
                    + "</tr>";
        }

        if(ignored === IGNORED_YES){
            ignored_count ++;
            softwareType = "ignored";
        }else{
            canBeUpgraded_count ++;
            softwareType = "canBeUpgraded";
        }

        if($(".showUpgradeSoftwares").has("[id='" + packageName + "']").length){
            $(".showUpgradeSoftwares [id='" + packageName + "']").replaceWith(html_str);
        }else {
            if(hasSoftwares){
                $(".showUpgradeSoftwares." + softwareType).prepend(html_str);
            }else {
                $(".showUpgradeSoftwares." + softwareType).append(html_str);
            }
        }
        

        if(status === STATUS_UPGRADING){
            $(".showUpgradeSoftwares [id='" + packageName + "'] .changeProgress").show();
            //$(".showUpgradeSoftwares [id='" + packageName + "'] .cv_nv").hide();
            $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_comm").hide();
            $(".showUpgradeSoftwares [id='" + packageName + "'] .changeAptExecType").empty().append("执行中");
        }else{
            $(".showUpgradeSoftwares [id='" + packageName + "'] .changeProgress").hide();
            //$(".showUpgradeSoftwares [id='" + packageName + "'] .cv_nv").show();
            $(".showUpgradeSoftwares [id='" + packageName + "'] .changeAptExecType").empty();
            if(ignored === IGNORED_YES){
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_recover").show();
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_ignore").hide();
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_upgrade").hide();
            }else{
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_recover").hide();
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_ignore").show();
                $(".showUpgradeSoftwares [id='" + packageName + "'] .btn_upgrade").show();
            }
        }

        $(".upgrade_total_count").text(canBeUpgraded_count);
        $(".office_count").text(office_count);
        $(".free_count").text(free_count);
        $(".charge_count").text(charge_count);
        $(".test_count").text(test_count);
        $(".canBeUpgraded_count").text(canBeUpgraded_count);
        $(".ignored_count").text(ignored_count);
        $(".fl_img img").unbind().on('error',function(){
                    img_error($(this));
        });
    }
}

function changeButtonStatus(isoftwares){
    for(var index in isoftwares){
        var software = isoftwares[index].software;
        var softwareStatus = isoftwares[index].softwareStatus;
        var APT_EXEC_STATUS = isoftwares[index].APT_EXEC_STATUS;
        var APT_PAUSE_STATUS = isoftwares[index].APT_PAUSE_STATUS;
        var APT_CANCEL_STATUS = isoftwares[index].APT_CANCEL_STATUS;
	    var _btn = $("[id='" + software + "'] .btn_comm");


        if(softwareStatus === STATUS_CAN_BE_INSTALLED){
            _btn.removeClass("btn01 btn02 disabled removeSoftware upgradeSoftware openSoftware")
                .addClass("btn03 installSoftware").removeAttr("disabled");
		    setText(_btn,"安装");
        }else if(softwareStatus === STATUS_INSTALLING){
            /*_btn.removeClass("btn01 btn02 installSoftware removeSoftware upgradeSoftware")
                .addClass("btn03 disabled").attr("disabled", true);*/
            _btn.attr("disabled", true);
	        if($(".showAPTTasks_small").size() > 0){
		        _btn.val("||");
            }else{
		        setText(_btn,"正在安装");
            }
        }else if(softwareStatus === STATUS_INSTALLED){
            _btn.removeClass("btn02 btn03 bt04 installSoftware removeSoftware upgradeSoftware openSoftware").addClass("btn01");
			if(!!isoftwares[index].method && isoftwares[index].method == 2){
                _btn.removeClass("disabled").removeAttr("disabled").addClass("openSoftware");
				setText(_btn,"打开");
			}else{
				_btn.removeClass("openSoftware").attr("disabled",true).unbind("click");
				setText(_btn,"已安装");
            }
            log("~~~ before listRemoveSoftwares");
            //新安装的软件自动加入到卸载列表，并保持在最上方
            listRemoveSoftwares();
            log("~~~ after listRemoveSoftwares");
        }else if(softwareStatus === STATUS_WAITINGAUTHORIZATION){
            _btn.attr("disabled", true);
            setText(_btn,"等待授权");
        }else if(softwareStatus === STATUS_CAN_BE_REMOVED){
            if($(".showRemoveSoftwares").length){
                _btn.filter(function(){
                    if($(this).val()==='正在卸载'){
                        return true;
                    }else{
                        return false;
                    }}).removeClass("btn01 btn03 disabled installSoftware upgradeSoftware")
		        .addClass("btn02 removeSoftware").removeAttr("disabled")
		        .val("卸载");
		    }else{
				 _btn.removeClass("btn02 btn03 btn04 installSoftware upgradeSoftware openSoftware").addClass("btn01");
			     if(!!isoftwares[index].method && isoftwares[index].method == 2){
                     _btn.removeClass("disabled").addClass("openSoftware").removeAttr("disabled");
                     setText(_btn,"打开");
                 }else{
				     _btn.removeClass("openSoftware").attr("disabled",true).unbind("click");
				     setText(_btn,"已安装");
                 }
		    }
        }else if(softwareStatus === STATUS_REMOVING){
            /*_btn.removeClass("btn01 btn03 installSoftware  upgradeSoftware")
                .addClass("btn02 disabled").attr("disabled", true);
	    if($(".showAPTTasks_small").size() > 0){
		_btn.val("||");
            }else{
		_btn.val("正在卸载");
            }*/
        }else if(softwareStatus === STATUS_REMOVED){
            _btn.removeClass("btn01 btn03 installSoftware removeSoftware upgradeSoftware openSoftware")
                .addClass("btn02 disabled").attr("disabled", true)
                .val("已卸载");
            //自动删除已卸载的软件所在行
            $(".showRemoveSoftwares [id='" + software + "']").remove();
            $(".remove_total_count").text(parseInt($(".remove_total_count").first().text()) );
//            alert(parseInt($(".remove_total_count").first().text()) - 1);
            //升级列表页面不需要改变（进入升级列表页面时，已经看不到正在卸载、已卸载的软件）
            //$(".upgrade_total_count").text(parseInt($(".upgrade_total_count").first().text()) - 1);
            //$(".showUpgradeSoftwares [id='" + software + "']").parent().parent().parent().prev().find("span")
                //.text(parseInt($(".showUpgradeSoftwares [id='" + software + "']").parent().parent().parent().prev().find("span").first().text()) - 1);
            //$(".showUpgradeSoftwares [id='" + software + "']").remove();
            //upgradeCountShow();
            //软件列表界面变换按钮为可安装状态
            _btn.removeClass("btn01 btn02 disabled removeSoftware upgradeSoftware openSoftware")
                .addClass("btn03 installSoftware").removeAttr("disabled");
            setText(_btn,"安装");
                window.location.reload();
        }else if(softwareStatus === STATUS_UPGRADE_FAILED){
            _btn.removeClass("btn01 btn03 installSoftware removeSoftware upgradeSoftware openSoftware")
                .addClass("btn02 disabled").attr("disabled", true)
                .val("已卸载");
            //自动删除已卸载的软件所在行
            $(".showRemoveSoftwares [id='" + software + "']").remove();
            $(".remove_total_count").text(parseInt($(".remove_total_count").first().text()));
            //upgradeCountShow();
            //软件列表界面变换按钮为错误状态
            _btn.removeClass("btn01 btn02 disabled removeSoftware upgradeSoftware openSoftware")
                .addClass("btn02 installSoftware").attr("disabled", true);
            _btn.addClass("disabled");
            setText(_btn,"错误");
                window.location.reload();
//            if(flag === 1){
//                 $.artDialog.alert("升级过程出现错误，您可进入软件详情重新安装该软件！");}
        }else if(softwareStatus === STATUS_CAN_BE_UPGRADED){
            _btn.removeClass("btn01 btn02 disabled installSoftware removeSoftware")
                .addClass("btn04 upgradeSoftware").removeAttr("disabled")
                .val("升级");
            $("[id='" + software + "'] .btn_comm.btn_ignore").removeClass("btn01 btn02 btn03 btn04 disabled installSoftware removeSoftware upgradeSoftware")
                .addClass("ignoreSoftware").removeAttr("disabled")
                .val("忽略").show();
            $("[id='" + software + "'] .btn_comm.btn_upgrade").removeClass("btn01 btn02 disabled installSoftware removeSoftware")
                .addClass("btn04 upgradeSoftware").removeAttr("disabled")
                .val("升级");
        }else if(softwareStatus === STATUS_UPGRADING){
            $("[id='" + software + "'] .btn_comm.btn_ignore").removeClass("btn01 btn02 btn03 btn04 installSoftware removeSoftware upgradeSoftware ignoreSoftware")
                .addClass("disabled").attr("disabled", true)
                .val("忽略");
            $("[id='" + software + "'] .btn_comm.btn_upgrade").removeClass("btn01 btn02 installSoftware removeSoftware ")
                .addClass("btn04 disabled").attr("disabled", true);
        }else if(softwareStatus === STATUS_UPGRADED){
            $("[id='" + software + "'] .btn_comm.btn_upgrade").removeClass("btn01 btn02 installSoftware removeSoftware upgradeSoftware")
                .addClass("btn04 disabled").attr("disabled", true)
                .val("已升级");
            //自动删除已升级的软件所在行
            $(".showUpgradeSoftwares [id='" + software + "']").remove();
            $(".upgrade_total_count").text(parseInt($(".upgrade_total_count").first().text()) - 1);
            $(".canBeUpgraded_count").text(parseInt($(".canBeUpgraded_count").first().text()) - 1);
            upgradeCountShow(parseInt($(".upgrade_total_count").first().text()) - 1);
		//add by gangjian
		_btn.removeClass("btn02 btn03 bt04 installSoftware removeSoftware upgradeSoftware openSoftware").addClass("btn01");
		if(!!isoftwares[index].method && isoftwares[index].method == 2){
			_btn.removeClass("disabled").removeAttr("disabled").addClass("openSoftware");
			setText(_btn,"打开");
		}else{
			_btn.removeClass("openSoftware").attr("disabled",true).unbind("click");
			setText(_btn,"已安装");
		}
		//end
            //新升级的软件自动加入到卸载列表，并保持在最上方
            listRemoveSoftwares();
        }else if(softwareStatus === STATUS_CAN_BE_CANCEL){
            if(APT_CANCEL_STATUS === "yes"){
                $("[id='" + software + "'] .btn_comm.btn_cancel").removeClass("btn01 btn02 btn03 btn04 disabled")
                    .addClass("cancelAPTTask").removeAttr("disabled")
                    .val("取消");
            }else {
                $("[id='" + software + "'] .btn_comm.btn_cancel").removeClass("btn01 btn02 btn03 btn04 cancelAPTTask")
                    .addClass("disabled").attr("disabled", true)
                    .val("取消");
            }
        }else if(softwareStatus === STATUS_CANCELING){
	        var _btn_c = $("[id='" + software + "'] .btn_comm.btn_cancel");
            _btn_c.removeClass("btn01 btn02 btn03 btn04 cancelAPTTask")
                .addClass("disabled").attr("disabled", true);
	        if($(".showAPTTasks_small").size() > 0){
		        _btn_c.val("×");
            }else{
		        _btn_c.val("正在取消");
            }
        }else if(softwareStatus === STATUS_CANCELED){

            var _btn_d  = $("[id='" + software + "'] .btn_comm.btn_ignore");
                if(_btn_d  !== undefined){
                    _btn_d.removeClass("btn01 btn02 btn03 btn04 disabled").removeAttr("disabled");
                    $(".ignoreSoftware").bind('click', function(){
                    ignoreSoftware_click($(this));
                    });
                $(".recoverSoftware").bind('click', function(){
                recoverSoftware_click($(this));
                });
            }

	        var _btn_c = $("[id='" + software + "'] .btn_comm.btn_cancel");
            _btn_c.removeClass("btn01 btn02 btn03 btn04 cancelAPTTask")
                .addClass("disabled").attr("disabled", true)
                .val("已取消");
	        setText($("[id='" + software + "'] .btn_comm.removeSoftware").removeClass("disabled").removeAttr("disabled"),"卸载");
            setText($("[id='" + software + "'] .btn_comm.upgradeSoftware").removeClass("disabled").removeAttr("disabled"),"升级");
            setText($("[id='" + software + "'] .btn_comm.installSoftware").removeClass("disabled").removeAttr("disabled"),"安装");
            setText($("[id='" + software + "'] .btn_comm.openSoftware").addClass("btn01").removeClass("disabled installSoftware upgradeSoftware removeSoftware btn02 btn03").removeAttr("disabled"),"打开");
		}else if(softwareStatus === STATUS_CAN_BE_PAUSE){
            if(APT_PAUSE_STATUS === "yes"){
                $("[id='" + software + "'] .btn_comm.btn_pause").removeClass("btn01 btn02 disabled")
                    .addClass("btn03 pauseAPTTask").removeAttr("disabled")
                    .val("暂停");
            }else {
                $("[id='" + software + "'] .btn_comm.btn_pause").removeClass("btn01 btn02 pauseAPTTask")
                    .addClass("btn03 disabled").attr("disabled", true)
                    .val("暂停");
            }
        }else if(softwareStatus === STATUS_PAUSING){
            var _btn_p = $("[id='" + software + "'] .btn_comm.btn_pause");
            _btn_p.removeClass("btn01 btn02 pauseAPTTask")
                .addClass("btn03 disabled").attr("disabled", true);
	        if($(".showAPTTasks_small").size() > 0){
		        _btn_c.val("||");
            }else{
		        _btn_c.val("正在暂停");
            }
        }else if(softwareStatus === STATUS_PAUSED){
            var _btn_p = $("[id='" + software + "'] .btn_comm.btn_pause");
	        var _btn_c = $("[id='" + software + "'] .btn_comm.btn_cancel");
            _btn_p.removeClass("btn01 btn02 pauseAPTTask");
	        if($(".showAPTTasks_small").size() > 0){
                _btn_p.removeClass("btn01 btn02 btn03 disabled ").addClass("btn_continue").removeAttr("disabled");
		        _btn_p.val("►");
            }else{
		        _btn_p.addClass("btn03 disabled").attr("disabled", true).val("继续");
            }
        }else if(softwareStatus === STATUS_DOWNLOADING){
            if(APT_EXEC_STATUS === "cancel"){
                setText(_btn, "安装");
            }else {
                setText(_btn, "正在下载");
            }
        }
    }

}

function getAPTExecType(isoftware) {
    var APT_CMD = isoftware.APT_CMD;
    var APT_EXEC_STATUS = isoftware.APT_EXEC_STATUS;
    var BYTES_DONE = isoftware.BYTES_DONE;
    var BYTES_TOTAL = isoftware.BYTES_TOTAL;
    var SPEED = isoftware.SPEED;
    var PROGRESS = isoftware.PROGRESS;
    var APT_PAUSE_STATUS = isoftware.APT_PAUSE_STATUS;
    var APT_CANCEL_STATUS = isoftware.APT_CANCEL_STATUS;
    var softwareStatus = isoftware.softwareStatus;
    var ERROR_MSG = isoftware.ERROR_MSG;
    var apt_exec_type = "";

    if (APT_EXEC_STATUS === "pending") {
        apt_exec_type = "等待";
    } else if(APT_EXEC_STATUS==="waitDownloading"){
        apt_exec_type = "等待下载";
    } else if(APT_EXEC_STATUS==="downloading"){
        apt_exec_type = "正在下载";
    } else if(APT_EXEC_STATUS==="waitInstall"){
        apt_exec_type = "等待安装";
    } else if(APT_EXEC_STATUS === "installing"){
         apt_exec_type = "正在安装";
    }else if(APT_EXEC_STATUS==="pause"){
        apt_exec_type = "暂停中";
    } else if(APT_EXEC_STATUS==="cancel"){
        apt_exec_type = "已取消";
    } else if (APT_EXEC_STATUS === "inprogress") {
        apt_exec_type = "执行中";
        if (0 <= PROGRESS && PROGRESS < 15) {
            apt_exec_type = "等待中";
        } else if (15 <= PROGRESS && PROGRESS <= 50) {
            if (APT_CMD === "download") {
                apt_exec_type = "下载中";
                if (SPEED === 0) {
                    apt_exec_type = "等待中";
                }
            } else if (APT_CMD === "install") {
                apt_exec_type = "下载中";
                if (SPEED === 0) {
                    apt_exec_type = "等待中";
                }
            } else if (APT_CMD === "remove") {
                apt_exec_type = "卸载中";
            } else if (APT_CMD === "upgrade") {
                apt_exec_type = "下载中";
                if (SPEED === 0) {
                    apt_exec_type = "等待中";
                }
            } else if (APT_CMD === "cancel") {
                apt_exec_type = "取消中";
            } else if (APT_CMD === "paused") {
                apt_exec_type = "暂停中";
            } else if (APT_CMD === "add_repository") {
                apt_exec_type = "添加源中";
            } else if (APT_CMD === "update") {
                apt_exec_type = "更新源中";
            }
        } else if (50 < PROGRESS && PROGRESS <= 100) {
            if (APT_CMD === "download") {
                apt_exec_type = "下载中";
                if (SPEED === 0) {
                    apt_exec_type = "等待中";
                }
            } else if (APT_CMD === "install") {
                apt_exec_type = "正在安装";
            } else if (APT_CMD === "remove") {
                apt_exec_type = "卸载中";
            } else if (APT_CMD === "upgrade") {
                apt_exec_type = "升级中";
            } else if (APT_CMD === "cancel") {
                apt_exec_type = "取消中";
            } else if (APT_CMD === "pause") {
                apt_exec_type = "暂停中";
            } else if (APT_CMD === "add_repository") {
                apt_exec_type = "添加源中";
            } else if (APT_CMD === "update") {
                apt_exec_type = "更新源中";
            }
        }
    } else if (APT_EXEC_STATUS === "success") {
        if(softwareStatus === STATUS_CANCELED || softwareStatus === STATUS_CAN_BE_UPGRADED || softwareStatus === STATUS_CAN_BE_REMOVED){
            apt_exec_type = "已取消";
        }else{
            apt_exec_type = "完成";
        }
    }else if (APT_EXEC_STATUS === "failed") {
//        apt_exec_type = "错误";
          apt_exec_type=errorMsg(ERROR_MSG)
    } else if (APT_EXEC_STATUS === "notAuthorized") {
        apt_exec_type = "取消授权";
    } else if (APT_EXEC_STATUS === "alreadyInstalled") {
        apt_exec_type = "已安装";
    } else if (APT_EXEC_STATUS === "notInstalled") {
        apt_exec_type = "已卸载";
    } else if (APT_EXEC_STATUS === "uptodate") {
        apt_exec_type = "已升级";
    } else if (APT_EXEC_STATUS === "downloadFailed") {
        apt_exec_type = "下载失败";
        //apt_exec_type = "失败";
    } else if (APT_EXEC_STATUS === "repoDownloadFailed") {
        //apt_exec_type = "更新源失败";
        apt_exec_type = "失败";
    } else if (APT_EXEC_STATUS === "paused") {
        apt_exec_type = "暂停";
    }

    return apt_exec_type;
}

function errorMsg(eCode){
    var ReturnValue=""

    if( eCode==="download failed")
        ReturnValue="下载安装文件失败";
    else if( eCode=== "repo update failed")
        ReturnValue="下载源索引文件失败";
    else if( eCode=== "dep failed")
        ReturnValue="依赖关系不满足或冲突";
    else if( eCode=== "key no install")
        ReturnValue="请安装软件密钥";
    else if( eCode=== "key no remove")
        ReturnValue="无法删除软件密钥";
    else if( eCode=== "no lock")
        ReturnValue="无法锁定软件包管理系统";
    else if( eCode===  "no cache")
        ReturnValue="无法打开包缓存";
    else if( eCode===  "no package")
        ReturnValue="没有找到可用的软件包";
    else if( eCode===  "not uptodate")
        ReturnValue="无法升级软件";
    else if( eCode===  "package no install")
        ReturnValue="无法卸载该软件";
    else if( eCode===  "already install")
        ReturnValue="软件已安装";
    else if( eCode===  "essential")
        ReturnValue="禁止删除基础依赖包";
    else if( eCode===  "daemon destroy")
        ReturnValue="Daemon 崩溃，无法连接DBUS";
    else if( eCode===  "manager failed")
        ReturnValue="调用Dpkg失败";
    else if( eCode===  "cache broken")
        ReturnValue="依赖关系被破坏请修复";
    else if( eCode===  "unauthenticated")
        ReturnValue="禁止安装未认证软件";
    else if( eCode===  "uninstall")
        ReturnValue="有软件没有完全安装请修复";

    else if( eCode===  "unreadable package file")
        ReturnValue="读写文件失败";

    else if( eCode===  "invalid package")
        ReturnValue="包文件有错误";

    else if( eCode===  "not update")
        ReturnValue="系统不需要升级";

    else if( eCode===  "no support")
        ReturnValue="不支持此操作";
    else if( eCode===  "license key error")
        ReturnValue="密钥无效";

    else if( eCode===   "license key download failed")
        ReturnValue="密钥下载失败";

    else if( eCode===  "unknown")
        ReturnValue="错误";

    return ReturnValue;
}
var normal_PROGRESS = 0;
function calcProgress(isoftware) {
    var APT_CMD = isoftware.APT_CMD;
    var APT_EXEC_STATUS = isoftware.APT_EXEC_STATUS;
    var BYTES_DONE = isoftware.BYTES_DONE;
    var BYTES_TOTAL = isoftware.BYTES_TOTAL;
    var SPEED = isoftware.SPEED;
    var PROGRESS = isoftware.PROGRESS;
    var APT_PAUSE_STATUS = isoftware.APT_PAUSE_STATUS;
    var APT_CANCEL_STATUS = isoftware.APT_CANCEL_STATUS;

    //if(APT_EXEC_STATUS === "inprogress"){
    if (0 <= PROGRESS && PROGRESS < 15) {
        if (SPEED === "") {
            PROGRESS = 0;
        }
    } else if (15 <= PROGRESS && PROGRESS <= 50) {
        if (APT_CMD === "install") {
            if (SPEED === "") {
                PROGRESS = PROGRESS / 10;
            } else {
                PROGRESS = PROGRESS * 2;
            }
        } else if (APT_CMD === "upgrade") {
            if (SPEED === "") {
                PROGRESS = PROGRESS / 10;
            } else {
                PROGRESS = PROGRESS * 2;
            }
        }
    } else if (50 < PROGRESS && PROGRESS <= 100) {
        if (APT_CMD === "install") {
            PROGRESS = (PROGRESS - 50) * 2;
        } else if (APT_CMD === "upgrade") {
            PROGRESS = (PROGRESS - 50) * 2;
        }
    }

    if (APT_CMD === "cancel") {
        PROGRESS = normal_PROGRESS - PROGRESS * normal_PROGRESS / 100;
    } else if (APT_CMD === "pause") {
        PROGRESS = normal_PROGRESS;
    } else {
        normal_PROGRESS = PROGRESS;
    }

    return PROGRESS;
}

/*
* 修改进度条函数
* */
function changeProgress(isoftwares){
    for(var index in isoftwares){
        var software = isoftwares[index].software;
        var softwareStatus = isoftwares[index].softwareStatus;
        var PROGRESS = calcProgress(isoftwares[index]);
        var apt_exec_type = getAPTExecType(isoftwares[index]);
        var APT_EXEC_STATUS = isoftwares[index].APT_EXEC_STATUS;
        var APT_CMD = isoftwares[index].APT_CMD;
        var method = isoftwares[index].method;
        changeProgressSingle(PROGRESS, software, softwareStatus, apt_exec_type,APT_EXEC_STATUS,APT_CMD,method);
	if(APT_CMD==="install" && softwareStatus === STATUS_INSTALLED && APT_EXEC_STATUS==="success")
	    {
	    	changeButtonStatus(isoftwares);
	    }
	if(APT_CMD==="upgrade" && APT_EXEC_STATUS==="success")
	    {
	    	changeButtonStatus(isoftwares);
	    }
	if(APT_CMD==="remove" && softwareStatus === STATUS_REMOVED && APT_EXEC_STATUS==="success")
	    {
		listRemoveSoftwares();
	    }
	if(APT_CMD==="remove" && APT_EXEC_STATUS==="failed")
	    {
	    	changeButtonStatus(isoftwares);
                $(".showAPTTasks_small li[id='"+software+"']").remove();
	     	if($(".showAPTTasks_small li").size() == 0)
		 {
		 	hideAPTTask_small();
		 }
	    }
	if(APT_CMD==="install" && APT_EXEC_STATUS==="failed")
	    {
	    	changeButtonStatus(isoftwares);
                $(".showAPTTasks_small li[id='"+software+"']").remove();
                $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("");
	     	if($(".showAPTTasks_small li").size() == 0)
		 {
		 	hideAPTTask_small();
		 }
	    }
	if(APT_CMD==="upgrade" && APT_EXEC_STATUS==="failed")
	    {
	    	changeButtonStatus(isoftwares);
                $(".showAPTTasks_small li[id='"+software+"']").remove();
                $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("");
	     	if($(".showAPTTasks_small li").size() == 0)
		 {
		 	hideAPTTask_small();
		 }
	    }
	if(APT_CMD==="download" && APT_EXEC_STATUS==="downloadFailed" && apt_exec_type ==="下载失败")
	    {
	     	if($(".showAPTTasks_small li").size() == 0)
		 {
		 	hideAPTTask_small();
		 }
	    }
    }
}

function changeProgressSingle(PROGRESS, software, softwareStatus, apt_exec_type,apt_exec_status,apt_cmd,method){
    log("---------->PROGRESS:" + PROGRESS + "software:"+software + "softwareStatus:"+softwareStatus +"apt_exec_type:"+apt_exec_type+" apt_exec_status:" +apt_exec_status+" apt_cmd:"+apt_cmd);

    if(apt_cmd === "download" && softwareStatus === STATUS_WAITDOWNLOAD && apt_exec_status=== "waitDownloading"){     //等待下载
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }


        if($(".showRecommendISoftwares").length > 0){
              $(".showRecommendISoftwares li[id='" + software + "'] .index").text(apt_exec_type);
        }

    }else if(apt_cmd === "download" && softwareStatus === STATUS_DOWNLOADING && apt_exec_status==="downloading"){   //正在下载
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }

        if($(".showRecommendISoftwares").length > 0){
              $(".showRecommendISoftwares li[id='" + software + "'] .index").text(apt_exec_type);
        }
    }else if(apt_cmd === "download" && softwareStatus === STATUS_DOWNLOADING && apt_exec_status === "paused"){   //正在下载，暂停
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }
        if($(".showRecommendISoftwares").length > 0){
              $(".showISoftwares li[id='" + software + "'] .index").text(apt_exec_type);
        }
    }else if(apt_cmd === "download" && softwareStatus === STATUS_DOWNLOADING && apt_exec_status === "cancel"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }
    }
    else if(apt_cmd === "install" && softwareStatus === STATUS_INSTALLING && apt_exec_status === "installing" ){    //正在安装
        if($(".showISoftwares").length > 0){
              if(PROGRESS === -1){
                   $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("等待安装");
              }else{
                   $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("正在安装");
              }

        }
    }else if(apt_cmd ==="install" && softwareStatus === STATUS_INSTALLING && apt_exec_status === "inprogress"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }
    }
    else if(apt_cmd === "install" && softwareStatus === STATUS_CAN_BE_INSTALLED && apt_exec_status === "notAuthorized"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
              $(".showISoftwares tr[id='" + software + "']").find(":button").val("安装");
              $(".showISoftwares tr[id='" + software + "']").find(":button").removeClass("disabled");
        }
    }else if(apt_cmd ==="install" && softwareStatus === STATUS_INSTALLED && apt_exec_status === "success"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
              var _this = $(".showISoftwares tr[id='" + software + "']").find(":button");
            _this.attr("btype", "");
            _this.removeClass("disabled");
            _this.removeClass("btn03");
            _this.removeClass("btn02");
            _this.removeClass("installSoftware");
            _this.removeClass("removeSoftware");
            _this.removeClass("upgradeSoftware");
            _this.addClass("btn01");
            $(this).unbind("click");
            if(method === 2){
                _this.val("打开");
                _this.addClass("openSoftware");
                $(this).removeClass("disabled");
                $(this).bind('click', function () {
                    opensoftware_click(_button);
                });
            }else{
                _this.val("已安装");
                $(this).addClass("disabled");
                $(this).removeClass("openSoftware");
            } 
        }
	    //add by gangjian
	    if($(".showRecommendISoftwares").length > 0){
              $(".showRecommendISoftwares [software='"+software+"']").text(apt_exec_type);
              var _this = $(".showRecommendISoftwares [software='" + software + "']");
            _this.attr("btype", "");
            _this.removeClass("disabled");
            _this.removeClass("btn03");
            _this.removeClass("btn02");
            _this.removeClass("installSoftware");
            _this.removeClass("removeSoftware");
            _this.removeClass("upgradeSoftware");
            _this.addClass("btn01");
            $(this).unbind("click");
            if(method === 2){
                _this.text("打开");
                _this.addClass("openSoftware");
                $(this).removeClass("disabled");
                $(this).bind('click', function () {
                    opensoftware_click(_button);
                });
            }else{
                _this.text("已安装");
                $(this).addClass("disabled");
                $(this).removeClass("openSoftware");
            }
        }
        if($(".showTopISoftwares").length > 0){
            $(".showTopISoftwares [software='"+software+"']").text(apt_exec_type);
            var _this = $(".showTopISoftwares [software='" + software + "']");
          _this.attr("btype", "");
          _this.removeClass("disabled");
          _this.removeClass("btn03");
          _this.removeClass("btn02");
          _this.removeClass("installSoftware");
          _this.removeClass("removeSoftware");
          _this.removeClass("upgradeSoftware");
          _this.addClass("btn01");
          $(this).unbind("click");
          if(method === 2){
              _this.text("打开");
              _this.addClass("openSoftware");
              $(this).removeClass("disabled");
              $(this).bind('click', function () {
                  opensoftware_click(_button);
              });
          }else{
              _this.text("已安装");
              $(this).addClass("disabled");
              $(this).removeClass("openSoftware");
          }
      }
      if($(".showTopDownloadISoftwares").length > 0){
            $(".showTopDownloadISoftwares [software='"+software+"']").text(apt_exec_type);
            var _this = $(".showTopDownloadISoftwares [software='" + software + "']");
        _this.attr("btype", "");
        _this.removeClass("disabled");
        _this.removeClass("btn03");
        _this.removeClass("btn02");
        _this.removeClass("installSoftware");
        _this.removeClass("removeSoftware");
        _this.removeClass("upgradeSoftware");
        _this.addClass("btn01");
        $(this).unbind("click");
        if(method === 2){
            _this.text("打开");
            _this.addClass("openSoftware");
            $(this).removeClass("disabled");
            $(this).bind('click', function () {
                opensoftware_click(_button);
            });
        }else{
            _this.text("已安装");
            $(this).addClass("disabled");
            $(this).removeClass("openSoftware");
        }
      }
	   //end
    }
    else if(apt_cmd === "install" && softwareStatus === STATUS_WAITINGAUTHORIZATION && apt_exec_status === "installing" ){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text('等待安装');
        }
      //  alert("---------------------------->" + $(".showRecommendISoftwares").length);
        if($(".showRecommendISoftwares").length > 0){
        //      alert( $(".showRecommendISoftwares li[id='" + software + "'] .index").parents().html());
              $(".showRecommendISoftwares li[id='" + software + "'] .index").text('等待安装');
        }
    }

    else if(apt_cmd === "cancel" && softwareStatus === STATUS_CANCELED && apt_exec_status === "success"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
        }


    }else if(apt_cmd === "cancel" && softwareStatus === STATUS_CAN_BE_REMOVED && apt_exec_status === "success"){
        if($(".showRemoveSoftwares").length > 0){
           $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").val("卸载");
           $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").removeClass("disabled");
           $(".showRemoveSoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
           $(".showRemoveSoftwares tr[id='" + software + "'] .openSoftware").show();
        }
    }

    else if(softwareStatus === STATUS_UPGRADING && apt_exec_status === "pending" && apt_exec_type === "等待"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("等待升级");
              $(".showISoftwares tr[id='" + software + "'] :button").val("等待升级");
        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
           //    $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text("等待升级");
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_upgrade").val("等待升级");
        }
    }
    else if(softwareStatus === STATUS_UPGRADING && apt_exec_status === "inprogress" && apt_exec_type === "等待中"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("正在升级");1
        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
             //  $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text("正在升级");
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_upgrade").val("正在升级");
        }
    }else if(softwareStatus === STATUS_UPGRADING && apt_exec_status === "inprogress" && (apt_exec_type === "下载中" || apt_exec_type === "升级中")){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("正在升级");
        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
         //      $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text("正在升级");
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_upgrade").val("正在升级");
        }
    }else if(softwareStatus === STATUS_UPGRADED && apt_exec_status === "success"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("完成");
        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
               //$(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text("完成");
               var count = $(".upgrade_total_count").text();
               /* 20171012 gaoshun del
               $(".upgrade_total_count").text(parseInt(count)-1);
               $(".canBeUpgraded_count").text(parseInt($(".canBeUpgraded_count").text())-1)
               ---------------------*/
               upgradeCountShow(parseInt(count)-1);
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "']").remove();
        }
    }else if(softwareStatus === STATUS_PAUSED && apt_exec_status === "paused"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text("暂停");
        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text("暂停");
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_upgrade").val("暂停");
        }
        if($(".showRemoveSoftwares").length > 0){
           $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").val("暂停");
           $(".showRemoveSoftwares tr[id='" + software + "'] .changeAptExecType").text("暂停");
        }
    }
    //升级模式下，取消升级
    else if(softwareStatus === STATUS_CAN_BE_UPGRADED && apt_exec_status === "success"){
        if($(".showISoftwares").length > 0){
              $(".showISoftwares tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
              $(".showISoftwares tr[id='" + software + "'] :button").val("升级");
              $(".showISoftwares tr[id='" + software + "'] :button").removeClass("disabled");

        }
        if($(".showUpgradeSoftwares.canBeUpgraded").length >0){
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .changeAptExecType").text(apt_exec_type);
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_upgrade").val("升级");
               $(".showUpgradeSoftwares.canBeUpgraded tr[id='" + software + "'] .btn_ignore").val("忽略");
        }
    }
    //卸载模式 等待卸载
    else if(apt_cmd === "remove" && softwareStatus === STATUS_REMOVING && apt_exec_status === "pending" && apt_exec_type === "等待"){
         if($(".showRemoveSoftwares").length > 0){
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").addClass("disabled");
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").val("等待卸载");
            $(".showRemoveSoftwares tr[id='" + software + "'] .openSoftware").hide();
            $(".showRemoveSoftwares tr[id='" + software + "'] .changeAptExecType").text("等待卸载");
         }
    }
    //卸载模式 等待中 和 卸载中
    else if(apt_cmd === "remove" && softwareStatus === STATUS_REMOVING && apt_exec_status === "inprogress" && (apt_exec_type === "等待中" || apt_exec_type === "卸载中"))
    {
         if($(".showRemoveSoftwares").length > 0){
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").addClass("disabled");
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").val("正在卸载");
            $(".showRemoveSoftwares tr[id='" + software + "'] .openSoftware").hide();
            $(".showRemoveSoftwares tr[id='" + software + "'] .changeAptExecType").text("正在卸载");
         }
    }
    //卸载模式 取消授权
    else if(apt_cmd === "remove" && softwareStatus === STATUS_CAN_BE_REMOVED && apt_exec_status === "notAuthorized"){
         if($(".showRemoveSoftwares").length > 0){
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").removeClass("disabled");
            $(".showRemoveSoftwares tr[id='" + software + "'] .removeSoftware").val("卸载");
            $(".showRemoveSoftwares tr[id='" + software + "'] .openSoftware").show();
            $(".showRemoveSoftwares tr[id='" + software + "'] .changeAptExecType").text("取消授权");
         }
    }else if(apt_cmd === "remove" && softwareStatus === STATUS_REMOVED && apt_exec_status === "success"){
        if($(".showRemoveSoftwares").length > 0){
           $(".showRemoveSoftwares tr[id='" + software + "']").remove();
        }
	 if($(".showRecommendISoftwares").length > 0){
              $(".showRecommendISoftwares [software='"+software+"']").text(apt_exec_type);
              var _this = $(".showRecommendISoftwares [software='" + software + "']");
            _this.attr("btype", "install");
            _this.removeClass("disabled");
            _this.removeClass("btn01");
            _this.removeClass("openSoftware");
            _this.addClass("btn03");
            _this.addClass("btn_comm");
            $(this).unbind("click");
            _this.text("安装");
            _this.addClass("installSoftware");
            $(this).removeClass("disabled");
            $(this).bind('click', function () {
                    installSoftware_click(_button);
            });
        }

    }

//    if(softwareStatus === STATUS_INSTALLING || softwareStatus === STATUS_REMOVING
//            || softwareStatus === STATUS_UPGRADING ){
//        var html_str = "";
//        html_str += "<div class='bar_w'>";
//        if(PROGRESS > 0 && PROGRESS <= 100){
//            html_str += "<span style='width:" + PROGRESS + "%'></span>";
//        }
//        html_str += "</div>";

//        $(".showISoftwares [id='" + software + "'] .changeProgress").show();
//        $(".showRemoveSoftwares [id='" + software + "'] .changeProgress").show();
//        $(".showUpgradeSoftwares [id='" + software + "'] .changeProgress").show();
//        $(".showISoftwares [id='" + software + "'] .btn_comm").hide();
//        $(".showRemoveSoftwares [id='" + software + "'] .btn_comm").hide();
//        $(".showUpgradeSoftwares [id='" + software + "'] .btn_comm").hide();

//    }else{

//        $(".showISoftwares [id='" + software + "'] .changeProgress").hide();
//        $(".showRemoveSoftwares [id='" + software + "'] .changeProgress").hide();
//        $(".showUpgradeSoftwares [id='" + software + "'] .changeProgress").hide();
//        $(".showISoftwares [id='" + software + "'] .btn_comm").show();
//        $(".showRemoveSoftwares [id='" + software + "'] .btn_comm").show();
//        $(".showUpgradeSoftwares [id='" + software + "'] .btn_comm").show();
//        $("[id='" + software + "'] .btn_recover").hide();
//    }
//    if(apt_exec_type === "安装中"){
//        $(".showISoftwares tr[id='" + software + "']").find(":button").show();
//    }
//    $("[id='" + software + "'] .changeProgress").append(html_str);
//    //列表按钮后面的执行状态
//    if(apt_exec_type === "正在取消" && softwareStatus === STATUS_DOWNLOADING){
//        //$("[id='" + software + "'] .changeAptExecType").empty();
//    }else {
//        $("[id='" + software + "'] .changeAptExecType").append(apt_exec_type);
//    }
//    if(apt_exec_type==="下载失败" || apt_exec_type==="错误" ){
//         $("[id='" + software + "'] div.bar_w span").addClass("error");
//    }


}


function getTasksNum(){
    if($(".showAPTTasks_small").children().length>0){
        
        return "false";
    }
    else
    {
       return "true";
    }
}

function closeAlert(){
    $.artDialog.alert("有任务正在进行, 禁止退出程序!");
}

function startUpdating (flag) {
    sync.update(flag);
}

function updateAlert(update,deletenum){
      html_str="检测到本地源中"
      if(update){
            html_str+="有"+update.toString()+"款软件可以更新，"
       }
       if(deletenum){
           html_str+="有"+deletenum.toString()+"款软件在网络源中已被删除，"
       }
       html_str+="是否需要同步？"
       $.artDialog.confirm(html_str,function(){
            startUpdating("1");
        },function(){
            startUpdating("0");
        });
}
function updateFinish(errorCount){
	if(errorCount ==0)
	{
                $.artDialog.alert("同步完成！");
	}
	else
	{
		$.artDialog.alert("同步完成！存在"+errorCount+"软件包无法同步");
	}
}

function installFinish(install){
	if(install == 0)
	{
        $.artDialog.alert("恭喜您，安装成功。");
	}
	else if(install == 1)
	{
		$.artDialog.alert("恭喜您，升级成功。");
	}
}

