/**
 JS方法调用QT方法
 */

/**
  输出消息日志
*/
function log(str) {
    QT.log(str);
}

/**
  获取左侧菜单
*/
function listSoftCategories(){
    var softCategories_return = QT.listSoftCategories();
    var softCategories = JSON.parse(softCategories_return);

    showSoftCategories(softCategories);
}

/**
  根据软件名获取分类信息
*/
function viewSoftCategory(software){
    var softCategory_return = QT.viewSoftCategory(software);
    var softCategory = JSON.parse(softCategory_return);

    showSoftCategory(softCategory);
}

/**
  下载安装壁纸
 * */
//add by gangjian
function downloadInstallWallpaper(papername)
{
	QT.downloadInstallWallpaper(papername);
}
//end

/**
  获取推荐软件信息
*/
function listRecommendISoftwares(){
    var isoftwares_return = QT.listRecommendISoftwares();
    var isoftwares = JSON.parse(isoftwares_return);
    showRecommendISoftwares(isoftwares);
}

/**
  获取排行软件信息
*/
function listTopISoftwares(){
    var isoftwares_return = QT.listTopISoftwares(10);
    var isoftwares = JSON.parse(isoftwares_return);

    showTopISoftwares(isoftwares);
}

/**
    获取本地软件版本号
*/
function getLocalSoftwareVersion(pkgName){
  return QT.getLocalSoftwareVersion(pkgName);
}

/**
  根据种类查询软件信息
*/
/**
function listISoftwaresByCategoryId(categoryId){
    var isoftwares_return = QT.listISoftwaresByCategoryId(categoryId);
    var isoftwares = JSON.parse(isoftwares_return);

    showISoftwares(isoftwares);
}
*/

/**
  查看软件详细信息
*/
function viewSoftware(software){
    var isoftwares_return = QT.viewSoftware(software);
    var isoftwares = JSON.parse(isoftwares_return);
    showSoftware(isoftwares);
}

/**
  记录软件评分评论信息
**/
function recordsoftwarescore(software, offline_comment, offline_score){
    QT.recordSoftwareScore(software,offline_comment, offline_score);
}

//function record_softwarecomment(software,comment){
//    QT.recordSoftwareComment(software, comment);

/**
  安装软件
*/
function installSoftware(software, cversion){
    log("~~~installSoftware");
    QT.installSoftware(software, cversion);
}

function getUpdateFlagApt(){
    var apt_update = QT.getUpdateFlagApt();
    return apt_update;
}

function updateSource(){
	QT.update();
}
/*
 * 获取winuxgear环境
 */
function getWinuxgearStatus(){
    var winux_exist = QT.getWinuxgearStatus();
    return winux_exist;
}

/*
 * 隐藏软件反馈窗口
 */
//function hideSoftwareFeedback(){
  //  QT.hideSoftwareFeedback();
//}

/*
 * 显示软件反馈窗口
 */
//function showSoftwareFeedback(urlpath,softwarename){
 //   QT.showSoftwareFeedback(urlpath,softwarename);
//}

/*
  继续下载
*/
function continueDownloading(software, cversion){
    QT.continueAPTTask(software, cversion);
}


/**
  列出APT任务
*/
function listAPTTasks(){
    var isoftwares_return = QT.listAPTTasks();
    var isoftwares = JSON.parse(isoftwares_return);

    showAPTTasks(isoftwares);
}

/**
  小窗口列出APT任务
*/
function listAPTTasks_small(){
    var isoftwares_return = QT.listAPTTasks();
    var isoftwares = JSON.parse(isoftwares_return);
    //showAPTTasks_small(isoftwares);
    showAPTTasks_small_new(isoftwares);
}

/**
  隐藏APT任务小窗口
*/
function hideAPTTask_small(){
    QT.hideAPTTask_small();
}

/**
  显示APT任务大窗口
*/
function showAPTTask_page(){
    QT.showAPTTask_page();
}

/**
   将JSON字符串切割成需要的长度
  */
function cutJson(index, num, softwares)
{
       var ret = "[";
        var mark = num;
        for(var i=0; i < softwares.length; i++)
        {
                if(i >= index)
                {
                    if(mark == num )
                    {
                        ret += JSON.stringify(softwares[i]);
                    }
                    else
                    {
                        ret += ",";
                        ret += JSON.stringify(softwares[i]);
                    }
                    if(--num == 0)
                        break;
                }
        }

        ret += "]";
        return JSON.parse(ret);
}


/**
  列出可以被删除的软件
*/
function listRemoveSoftwares(){
    var softwares_return = QT.listRemoveSoftwares();
    var softwares = JSON.parse(softwares_return);
    var _current = 1;
    var _pageSize = 12;
    var _pageCount = Math.ceil(softwares.length / _pageSize );
    var currentRemovelist;
log("~~~ in listRemoveSoftwares:" + softwares.length);
   /* if(softwares.length > _pageSize)
    {
        currentRemovelist =cutJson(0, _pageSize, softwares);
        showRemoveSoftwares(currentRemovelist);
        //by zhouchang
      $("#table_height").append('<div id="pagination"></div>');
          $("#pagination").myPagination({
                  currPage:_current,
                  pageCount:_pageCount,
                  cssStyle:'digg',
                  pageSize:_pageSize,
                  ajax:{
                            on:false,
                            onClick:function(page){
                                 if(page == 1)
                                 {
                                     $(".showRemoveSoftwares").empty();
                                     currentRemovelist =cutJson(0, _pageSize, softwares);
                                     showRemoveSoftwares(currentRemovelist);
                                 }
                                 else
                                 {
                                     if((softwares.length-(page-1)*12) >=  _pageSize)
                                     {
                                         $(".showRemoveSoftwares").empty();
                                         currentRemovelist =cutJson((page-1)*12, _pageSize, softwares);
                                         showRemoveSoftwares(currentRemovelist);
                                     }
                                     else
                                     {
                                         $(".showRemoveSoftwares").empty();
                                         currentRemovelist =cutJson((page-1)*12, softwares.length - (page-1)*12, softwares);
                                         showRemoveSoftwares(currentRemovelist);
                                     }
                                 }
                              }
                  },
                  panel:{
                                  'first_on':true,
                                  'last_on':true
                  }
          });
    }
    else
    {*/
        showRemoveSoftwares(softwares);
  //  }

}

function listRemoveSoftwaresByID()
{
	var soft_return = QT.listRemoveSoftwaresByID();
	return soft_return;
}

/**
  卸载软件
*/
function removeSoftware(packageName, cv){
    QT.removeSoftware(packageName, cv);
}

function updateNum(){
    //listUpgradeSoftwares();

}
/**
  列出可以被升级的软件
*/
function listUpgradeSoftwares(){
    var softwares_return = QT.listUpgradeSoftwares();
    var softwares = JSON.parse(softwares_return);
//    //这里需要对列表进行过滤
//    $.post(urls.url+"/softwareIsPublished_JSON.action", {"json":softwares_return},function(text,status){
//             var softArray = new Array();
//             var arr = $.parseJSON(text);
//                for(var i=0;i<softwares.length;i++){
//                    for(var j=0;j<arr.length;j++){
//                        if(softwares[i].packageName == arr[j]){
//                               softArray.push(softwares[i]);
//                        }
//                    }
//                }
//                 showUpgradeSoftwares(softArray);
//            });



    showUpgradeSoftwares(softwares);
}

/**
  忽略软件
*/
function ignoreSoftware(packageName, nv){
    var ignored = QT.ignoreSoftware(packageName, nv, IGNORED_YES);
    showIgnoredSoftware(packageName, ignored);
    changedUpgradeSoftwaresNumber(ignored);
}

/**
  恢复软件
*/
function recoverSoftware(packageName, nv){
    var ignored = QT.ignoreSoftware(packageName, nv, IGNORED_NO);
    log(ignored);

    showIgnoredSoftware(packageName, ignored);
    changedUpgradeSoftwaresNumber(ignored);
}

/**
  升级软件
*/
function upgradeSoftware(packageName, nv){
    QT.upgradeSoftware(packageName, nv);
}

/**
  取消任务（目前只能取消下载任务）
*/
function cancelAPTTask(software, cversion){
    QT.cancelAPTTask(software, cversion);
}

/**
  暂停任务（目前只能暂停下载任务）
*/
function pauseAPTTask(software, cversion){
    QT.pauseAPTTask(software, cversion);
}

/**
  可升级软件数量显示
*/
function upgradeCountShow(count){
    QT.upgradeCountShow(count);
}

/**
  搜索软件信息
*/
function searchISoftwares(categoryId, keyword, sortField, sort){
    var isoftwares_return = QT.searchISoftwares(categoryId, keyword, sortField, sort);
    var isoftwares = JSON.parse(isoftwares_return);
    showISoftwares(isoftwares);
}

/**
  分页搜索软件信息
*/
function searchISoftwares_datapage(categoryId, keyword, sortField, sort, pageNo){
    $(".showISoftwares").empty();
    var datapage_isoftwares_return = QT.searchISoftwares(categoryId, keyword, sortField, sort, pageNo);
    var datapage_isoftwares = JSON.parse(datapage_isoftwares_return);

    var isoftwares_return = datapage_isoftwares.data;
    if(!!!isoftwares_return){
	isoftwares_return="[]";
    }
    var isoftwares = JSON.parse(isoftwares_return);
    showISoftwares(isoftwares);

    var totalCount = datapage_isoftwares.totalCount;
    var currPage = datapage_isoftwares.currentPageNo;
    var pageCount = datapage_isoftwares.totalPageCount;
    if(totalCount > 0){
        $("#pagination").myPagination({
             currPage: currPage,
             pageCount: pageCount,
             cssStyle:'digg',
             ajax:{
               onClick:function(page){
                   //开启提示代码,需导入msgbox.js文件与样式.
                   //ZENG.msgbox.show(" 正在加载"+page+"页，请稍后...", 6, 1000);
                  pageNo = page;
                  searchISoftwares_datapage(categoryId, keyword, sortField, sort, pageNo);
               }
             },
             panel:{
                 'first_on':true,
                 'last_on':true
             }
        });
         _checkSoftwareStatus();
    }
}

/**
  搜索卸载列表软件信息
*/
function searchRemoveSoftwares(keyword){
    var softwares_return = QT.searchRemoveSoftwares(keyword);
    var softwares = JSON.parse(softwares_return);

    showRemoveSoftwares(softwares);
}

/**
  搜索升级列表软件信息
*/
function searchUpgradeSoftwares(keyword){
    var softwares_return = QT.searchUpgradeSoftwares(keyword);
    var softwares = JSON.parse(softwares_return);

    showUpgradeSoftwares(softwares);
}

function getOffline(){
    var offline = QT.getOffline();
    return offline;
}
function checkScorestatus(packageName,usrID){
    return QT.checkScorestatus(packageName,usrID);
}
function checkCommentstatus(packageName,usrID){
    return QT.checkCommentstatus(packageName,usrID);
}
function updateScorestatus(packageName,usrID){
    QT.updateScorestatus(packageName,usrID);
}
function updateCommentstatus(packageName,usrID){
    QT.updateCommentstatus(packageName,usrID);
}

function updateScorestatus(packageName,usrID,scoreValue){
    QT.updateScorestatus(packageName,usrID,scoreValue);
}
function getScoreValue(packageName,usrID){
    return QT.getScoreValue(packageName,usrID);
}
//add by gangjian
function browOpen(urltmp)
{
	QT.browOpen(urltmp);
}
function getArch()
{
  return QT.getArch();
}
//end
