(function($) {
	$.fn.order = function(options) {
		var _opts = $.extend({}, $.fn.order.defaults, options);
		var $this = $(this);
		$this.click(function(){
			var _this = $(this);
			if(_opts.remote){
				var column =_this.attr(_opts.column);
				var _href = window.location.href;
				var _search = window.location.search;
				var _url = _href.replace(_search, "");
				var _order_r = new RegExp("("+_opts.order+"=.*)$", "");
				if(_search.indexOf(_opts.order+"=") > -1){
					_search = _search.replace(_order_r, _opts.order+"="+column);
				}else{
					if(_search.length >= 2){
						_search += ("&"+_opts.order+"="+column);
					}else{
						_search = ("?"+_opts.order+"="+column);
					}
				}
				window.location.href = (_url+_search);
			}else{
				var index = _this.parents($.trim(_opts.positionTag)).index();
				var _ptarget = $(_opts.target).parent();
				var _list = $(_opts.target);
				var _keys = [];
				var _map = {};
				for(var i = 0; i < _list.size(); i ++){
					var _value = $(_list.get(i));
					var _key = $(":nth-child("+(index+1)+")",_value).text();
					var _vs = _map[_key];
					if(!!!_vs){
						_vs = [];
					}
					_vs.push(_value);
					_map[_key] = _vs;
					_keys.push(_key);
				}
				var _p = $(this).parent();
				if(_p.hasClass("selected")){
					_p.removeClass("selected");
					_keys.sort(function(a, b){return (a>b?1:-1);});
				}else{
					_p.addClass("selected");
					_keys.sort(function(a, b){return (a>b?-1:1);});
				}
				_p.siblings().removeClass("selected");
				for(var i in _keys){
					var _vs = _map[_keys[i]];
					for(var j in _vs){
						_ptarget.append(_vs[j]);
					}
				}
			}
		});
	};
	$.fn.order.defaults={
			target:".slist",
			positionTag:"th",
			column:"column",
			order:"order",
			offset:0,
			remote:false
	};
})(jQuery);